/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

 /***************************************************************************
 *            CoverLib.c						                            *
 ****************************************************************************/
/**
Thanks to 
http://sarine.nl/amazon-provider
Thanks to gmpc project**/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include <GL/gl.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <curl/curl.h>
#include <glade/glade.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#include "../include/main.h"
#include "../include/LibCover.h"

#define CURL_TIMEOUT 500
/**
If you want an amazon developer key see here:
http://www.amazon.com/gp/browse.html?node=3435361
**/
#define AMAZONKEY "1CW78PFZ74NBTM5QZ1G2"

typedef struct amazon_song_info {
	char *image_big;
	char *image_medium;
	char *image_small;
	char *album_info;

}amazon_song_info;


typedef void (*ProgressCallback)(int downloaded, int total, gpointer data);
typedef struct _gmpc_easy_download_struct{
	char *data;
	int size;
	int max_size;
	ProgressCallback callback;
	gpointer callback_data;
}gmpc_easy_download_struct;


char * __cover_art_process_string(char *name);
int fetch_cover_art(char *sArtiste,char *sAlbum);
int __fetch_metadata_amazon(char *stype, char *nartist, char *nalbum);
int gmpc_easy_download(const char *url,gmpc_easy_download_struct *dld);
void gmpc_easy_download_clean(gmpc_easy_download_struct *dld);

static char * host = "http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&Operation=ItemSearch&SearchIndex=Music&ResponseGroup=Images,EditorialReview&SubscriptionId=%s&Artist=%s&%s=%s";
static char* search_types[] = {"Title", "Keywords"};


/* Replace special char */
char * __cover_art_process_string(char *name)
{
	unsigned int i = 0;
	unsigned int j = 0;
	int depth = 0;
	int length = 0;
	char *result, *result2;
	/* only gonna be smaller */
	char *norm = NULL;
	norm = g_utf8_normalize(name, -1, G_NORMALIZE_ALL);
//	result2 = g_convert_with_fallback(norm, -1, "ISO8859-15", "utf-8", "",NULL,NULL,NULL);
	result2 = g_malloc0(strlen(norm)+2);
	if(norm)
	{
		/*gchar *normal;*/
		gchar *p;
		gunichar c;
		j=0;
		p = norm;
		c = g_utf8_get_char(norm);
		while(c) {
			switch(g_unichar_type(c)) {
				case G_UNICODE_COMBINING_MARK:
				case G_UNICODE_ENCLOSING_MARK:
				case G_UNICODE_NON_SPACING_MARK:
					break;
				default:
					switch(c) {
						case 0x00df:
							snprintf(&result2[j],3,"ss");
							j+=2;
							break;
						case 0x00c6:
							snprintf(&result2[j],3,"AE");
							j+=2;
							break;
						case 0x00e6:
							snprintf(&result2[j],3,"ae");
							j+=2;
							break;
						case 0x0152:
							snprintf(&result2[j],3,"OE");
							j+=2;
							break;
						case 0x0153:
							snprintf(&result2[j],3,"oe");
							j+=2;
							break;
						case 0x00d0:
						case 0x0110:
							snprintf(&result2[j],2,"D");
							j+=1;
							break;
						case 0x00f0:
						case 0x0111:
							snprintf(&result2[j],2,"d");
							j+=1;
							break;
						case 0x0126:
							snprintf(&result2[j],2,"H");
							j+=1;
							break;
						case 0x0127:
							snprintf(&result2[j],2,"h");
							j+=1;
							break;
						case 0x0131:
							snprintf(&result2[j],2,"i");
							j+=1;
							break;
						case 0x0138:
							snprintf(&result2[j],2,"k");
							j+=1;
							break;
						case 0x013f:
						case 0x0141:
							snprintf(&result2[j],2,"L");
							j+=1;
							break;
						case 0x0140:
						case 0x0142:
							snprintf(&result2[j],2,"l");
							j+=1;
							break;
						case 0x014a:
							snprintf(&result2[j],2,"N");
							j+=1;
							break;
						case 0x0149:
						case 0x014b:
							snprintf(&result2[j],2,"n");
							j+=1;
							break;
						case 0x00d8:
							snprintf(&result2[j],2,"O");
							j+=1;
							break;
						case 0x00f8:
							snprintf(&result2[j],2,"o");
							j+=1;
							break;
						case 0x017f:
							snprintf(&result2[j],2,"s");
							j+=1;
							break;
						case 0x00de:
						case 0x0166:
							snprintf(&result2[j],2,"T");
							j+=1;
							break;
						case 0x00fe:
						case 0x0167:
							snprintf(&result2[j],2,"t");
							j+=1;
							break;
						default:
							if (c >= 0 && c <= 0x80) {
								snprintf(&result2[j],2,"%c", c);
								j++;
							}
							break;
					}
					break;
			}
			p = g_utf8_next_char(p);
			c = g_utf8_get_char(p);
			if(j>strlen(norm))
			{
				printf("LOG::CoverLib.c::__cover_art_process_string: String to large\n");
			}
		}
	}

	g_free(norm);
	length = strlen(name);
	for(i=0; i<strlen(name);i++)
	{
		if(!(name[i] >= 'a' && name[i] <= 'z') &&
				!(name[i] >= 'A' && name[i] <= 'Z') &&
				!(name[i] >= '0' && name[i] <= '9'))
		{
			length+=2;
		}

	}
	/** allocate */
	/** TODO do this somewhere else */
	result = g_malloc0((length+1)*sizeof(char));
	j=0;
	depth = 0;
	for(i=0; i < strlen(result2);i++) {
		if(result2[i] == '(' || result2[i] == '[' || result2[i] == '{')
		{
			depth++;
		}
		else if(result2[i] == ')' || result2[i] == ']' || result2[i] == '}') {
			depth--;
		}
		else if(depth >0)
		{
			/* do nothing */
		}
		else if(!(result2[i] >= 'a' && result2[i] <= 'z') &&
				!(result2[i] >= 'A' && result2[i] <= 'Z') &&
				!(result2[i] >= '0' && result2[i] <= '9')) {
			snprintf(&result[j],4,"%%%02X", result2[i]);
			j+=3;
		} else {
			result[j] = result2[i];
			j++;
		}
	}
	g_free(result2);

	return result;
}




static size_t write_data(void *buffer, size_t size, size_t nmemb, gmpc_easy_download_struct *dld)
{
	if(!size || !nmemb)
		return 0;
	if(dld->data == NULL)
	{
		dld->size = 0;
	}
	dld->data = g_realloc(dld->data,(gulong)(size*nmemb+dld->size)+1);

	memset(&(dld->data)[dld->size], '\0', (size*nmemb)+1);
	memcpy(&(dld->data)[dld->size], buffer, size*nmemb);

	dld->size += size*nmemb;
	if(dld->size >= dld->max_size && dld->max_size > 0)
	{
		return 0;
	}
	return size*nmemb;
}

int gmpc_easy_download(const char *url,gmpc_easy_download_struct *dld)
{
	int timeout = 0;
	int running = 0;
	int msgs_left = 0;
	int success = FALSE;
	CURL *curl = NULL;
	CURLM *curlm = NULL;
	CURLMsg *msg = NULL;
	double total_size = 0;
	/*int res;*/
	if(!dld) return 0;
	if(url == NULL) return 0;
	if(url[0] == '\0') return 0;
	/**
	 * Make sure it's clean
	 */
	gmpc_easy_download_clean(dld);
	/* initialize curl */
	curl = curl_easy_init();
	if(!curl) return 0;
	curlm = curl_multi_init();
	if(!curlm) return 0;

	/* set uri */
	curl_easy_setopt(curl, CURLOPT_URL, url);
	/* set callback data */
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, dld);
	/* set callback function */
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
	/* set timeout */
	timeout = CURL_TIMEOUT;
	curl_easy_setopt(curl, CURLOPT_CONNECTTIMEOUT, timeout);
	/* set redirect */
	curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION ,1);
	/* set NO SIGNAL */
	curl_easy_setopt(curl, CURLOPT_NOSIGNAL, TRUE);

	/*if(cfg_get_single_value_as_int_with_default(config, "Network Settings", "Use Proxy", FALSE))
	{
		char *value = cfg_get_single_value_as_string(config, "Network Settings", "Proxy Address");
		int port =  cfg_get_single_value_as_int_with_default(config, "Network Settings", "Proxy Port",8080);
		if(value)
		{
			curl_easy_setopt(curl, CURLOPT_PROXY, value);
			curl_easy_setopt(curl, CURLOPT_PROXYPORT, port);
			cfg_free_string(value);
		}
		else{
			debug_printf(DEBUG_ERROR ,"Proxy enabled, but no proxy defined");
		}
	}*/
	
	curl_multi_add_handle(curlm, curl);
	do{
		curl_multi_perform(curlm, &running);
		g_usleep(10000);
		if(dld->callback)
		{
			if(!(total_size > 0 ))
			{
				curl_easy_getinfo(curl, CURLINFO_CONTENT_LENGTH_DOWNLOAD, &total_size); 
			}
			dld->callback(dld->size, (int)total_size, dld->callback_data);
		}
		while ((msg = curl_multi_info_read(curlm, &msgs_left))) {	
			if (msg->msg == CURLMSG_DONE)
			{
				#ifdef DEBUG_COVER
					g_print("LOG::CoverLib.c::gmpc_easy_download:Reading data ...\n");
				#endif
				if( (!msg->data.result|| msg->data.result == 23)) {
					success = TRUE;
				}
				else
				{
					printf("Error: %i '%s' url: %s",
						msg->data.result,
						curl_easy_strerror(msg->data.result),
						url);
				}
			}
		}
	}while(running);
	/**
	 * remove handler
	 */
	curl_multi_remove_handle(curlm, curl);
	/* cleanup */
	curl_easy_cleanup(curl);
	curl_multi_cleanup(curlm);
	#ifdef DEBUG_COVER
		g_print("LOG::CoverLib.c::gmpc_easy_download:Downloaded: %i\n", dld->size);
	#endif
	if(success) return 1;
	
	if(dld->data) free(dld->data);
	dld->data = NULL;
	return 0;
}

void gmpc_easy_download_clean(gmpc_easy_download_struct *dld)
{
	if(dld->data)free(dld->data);
	dld->data = NULL;
	dld->size = 0;
}

amazon_song_info * amazon_song_info_new()
{
	amazon_song_info *asi = g_malloc(sizeof(amazon_song_info));
	asi->image_big = NULL;
	asi->image_medium = NULL;
	asi->image_small = NULL;
	asi->album_info = NULL;
	return asi;
}
void amazon_song_info_free(amazon_song_info *asi)
{
	if(asi->image_big != NULL) g_free(asi->image_big);
	if(asi->image_medium != NULL) g_free(asi->image_medium);
	if(asi->image_small != NULL) g_free(asi->image_small);
	if(asi->album_info != NULL) g_free(asi->album_info);
	g_free(asi);
	return;
}


xmlNodePtr get_first_node_by_name(xmlNodePtr xml, gchar *name) {
	if(xml) {
		xmlNodePtr c = xml->xmlChildrenNode;
		for(;c;c=c->next) {
			if(xmlStrEqual(c->name, (xmlChar *) name))
				return c;
		}
	}
	return NULL;
}

amazon_song_info *__cover_art_xml_get_image(char *data,int size)
{
	xmlDocPtr doc = xmlParseMemory(data,size);
	if(doc)
	{
		xmlNodePtr root = xmlDocGetRootElement(doc);
		xmlNodePtr cur = get_first_node_by_name(root, "Items");
		amazon_song_info *asi = NULL; 
		#ifdef DEBUG_COVER
			printf("start Xml __cover_art_xml_get_image\n");
		#endif
		if(cur) {
			cur = get_first_node_by_name(cur, "Item");
			if(cur) {
				xmlNodePtr child = NULL;
				asi = amazon_song_info_new();
				if((child = get_first_node_by_name(cur, "LargeImage"))) {
					xmlChar *temp = xmlNodeGetContent(get_first_node_by_name(child, "URL")); 
					/* copy it, so we can free it, and don't need xmlFree */
					asi->image_big = g_strdup((char *)temp);
					xmlFree(temp);
				}
				if((child = get_first_node_by_name(cur, "MediumImage"))){
					xmlChar *temp = xmlNodeGetContent(get_first_node_by_name(child, "URL"));
					asi->image_medium = g_strdup((char *)temp);
					xmlFree(temp);
				}
				if((child = get_first_node_by_name(cur, "SmallImage"))){
					xmlChar *temp = xmlNodeGetContent(get_first_node_by_name(child, "URL"));
					asi->image_small = g_strdup((char *)temp);
					xmlFree(temp);
				}	

				if ((child = get_first_node_by_name(cur, "EditorialReviews"))) { 
					child = get_first_node_by_name(child, "EditorialReview");
					if(child) {
						xmlChar *temp = xmlNodeGetContent(get_first_node_by_name(child, "Content")); /* ugy, lazy */
						asi->album_info = g_strdup((char *)temp);
						xmlFree(temp);
					}
				}
			}
		}
		xmlFreeDoc(doc);
		return asi;
	}
	xmlCleanupParser();
	return NULL;
}




int __fetch_metadata_amazon(char *stype, char *nartist, char *nalbum)
{

	gmpc_easy_download_struct data= {NULL, 0,-1, NULL, NULL};
	int  found = 0;
	char furl[1024];

	snprintf(furl,1024, host, AMAZONKEY, nartist, stype, nalbum);
	#ifdef DEBUG_COVER
		printf("search-type: %s\n", furl);
	#endif
	if(gmpc_easy_download(furl, &data))
	{	
		#ifdef DEBUG_COVER
			printf("start Xml get image\n");
		#endif
		amazon_song_info *asi = __cover_art_xml_get_image(data.data, data.size);
		gmpc_easy_download_clean(&data);
		if(asi) 
		{
			gmpc_easy_download(asi->image_big, &data);
			if(data.size <= 900){
				gmpc_easy_download_clean(&data);
				gmpc_easy_download(asi->image_medium, &data);
				if(data.size <= 900){
					gmpc_easy_download_clean(&data);
					gmpc_easy_download(asi->image_small, &data);
					if(data.size <= 900)
					{
						gmpc_easy_download_clean(&data);
					}
				}
			}
			if(data.size){
				/*int i =0;*/
				FILE *fp = NULL;
				char *imgpath = NULL;
				imgpath = g_strdup_printf("%s%s-%s.jpg",
						j3denv->__sCoverPath__,nartist,nalbum);
				#ifdef DEBUG_COVER
					g_print("Opening %s%s-%s.jpg\n",j3denv->__sCoverPath__,nartist,nalbum);
				#endif
				fp = fopen(imgpath, "wb");
				if(fp)
				{
					#ifdef DEBUG_COVER
						printf("writing data..\n");
					#endif
					fwrite(data.data, sizeof(char), data.size,fp);
					fclose(fp);
				}else{printf("Erreur de path\n");}
				g_free(imgpath);
				if(asi->album_info)
				{
					imgpath = g_strdup_printf("%s%s-%s.albuminfo",
							j3denv->__sCoverPath__,nartist,nalbum);


					fp = fopen(imgpath, "w");
					if(fp)
					{
						unsigned int j=0;
						int depth=0;;
						/**
						 * Quick 'n Dirty html stripper
						 */
						for(j=0; j < strlen(asi->album_info);j++)
						{
							if((asi->album_info)[j]	 == '<') depth++;
							else if((asi->album_info)[j] == '>' && depth) depth--;
							else if(depth == 0)
							{
								fputc((asi->album_info)[j],fp);
							}
						}
						fclose(fp);
					}

					g_free(imgpath);
				}

				gmpc_easy_download_clean(&data);
				found = 1;
				#ifdef DEBUG_COVER
					printf("Found album\n");
				#endif
			}
			/*printf("Info non trouvé\n");*/
			amazon_song_info_free(asi);
		}

	}

	return found;
}




int fetch_metadata(char *sArtiste,char *sAlbum)
{
	char path[256];
	int j=2;
	gchar *url=NULL;

	/*if(song->artist == NULL || song->album == NULL)
	{
		return META_DATA_UNAVAILABLE;
	}
	if(type != META_ALBUM_ART && type != META_ALBUM_TXT) {
		return META_DATA_UNAVAILABLE;
	}*/
	
	gchar *artist = __cover_art_process_string(sArtiste);
	gchar *album =  __cover_art_process_string(sAlbum);

	/*if(type == META_ALBUM_TXT)
		url = g_strdup_printf("%s/.covers/%s-%s.albuminfo", g_get_home_dir(), artist, album);*/
	/*else*/ url = g_strdup_printf("%s%s-%s.jpg", j3denv->__sCoverPath__, artist, album);

	/* need to loop twice, but only fetch once */
	while(j) {
		/* need to test in case it has been downloaded by the other type */
		if(g_file_test(url, G_FILE_TEST_EXISTS)) {
			/**path = url;*/
			strcpy(path,url);
			#ifdef DEBUG_COVER
				printf("Already downloaded: %s\n", url);
			#endif
			g_free(url);
			g_free(artist);
			g_free(album); 		
			return 0;
		}

		/* trying to get info */
		if(--j) {
			#ifdef DEBUG_COVER
				printf("Try to fetch data.. \n");
			#endif
			fetch_cover_art(sArtiste, sAlbum);
		}
	}
	#ifdef DEBUG_COVER
		printf("Free memory\n");
	#endif
		
	g_free(url);
	g_free(artist);
	g_free(album); 	
	return 0; 
}	

int fetch_cover_art(char *sArtiste,char *sAlbum)
{
	int retval=0,i=0;
	gchar *artist = __cover_art_process_string(sArtiste);
	gchar *album =  __cover_art_process_string(sAlbum);

	while(!retval&&i<2)
	{
		retval = __fetch_metadata_amazon(search_types[i++], artist, album);
		#ifdef DEBUG_COVER
			printf("Type de recherche: %s\n",search_types[i]);
		#endif
	}
	#ifdef DEBUG_COVER
		printf("Liberation memoire fetch_cover_art\n");
	#endif
	g_free(artist);
	g_free(album);
	return retval;
}


/**Executing amazon query**/
void exec_cover(char *album,char *artist)
{
	pid_t pid;
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork");
			return;
		case 0:
			/*execlp("data/Query_amazon","data/Query_amazon", artist, album, NULL);*/
			/*perror("execlp");*/
			fetch_metadata(album,artist);
			
			exit(1);
		default:
			// don't waitpid here, use SIGCHLD or SA_NOCLDWAIT
			return;
	}
    return;
}

/*
int main(int argc, char *argv[]){
	int i;

    for (i=0; i < argc; i++)
    {
        printf("Argument %i : %s \n", i+1, argv[i]);
    }
	printf("Fetch metadata \n");
	if (argc==3)
	{
		fetch_metadata(argv[2],argv[1]);
	}
	
	return 1;
}
*/

