/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            FileLib.c							 *
 *************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <gtk/gtk.h>

#include "../include/main.h"

int CopyFile(char *source,char *destination)
{
 	FILE *in, *out;
 	char ch;
 	#ifdef DEBUG_FILELIB
 		printf("Log-FileLib.c::CopyFile: Source %s Destination %s\n",source,destination);
	#endif
	if((in=fopen((char *)source, "rb")) == NULL) {
    	printf("Cannot open input file.\n");
    	exit(1);
  	}
  	if((out=fopen((char *)destination, "w+")) == NULL) {
    	printf("Cannot open output file.\n");
    	exit(1);
  	}
  while(!feof(in)) {
    ch = getc(in);
    if(ferror(in)) {
      printf("Read Error");
      clearerr(in);
      break;
    } else {
      if(!feof(in)) putc(ch, out);
      if(ferror(out)) {
        printf("Write Error");
        clearerr(out);
        break;
      }
    }
  }
  fclose(in);
  fclose(out);

  return 0;
}
