/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            LibImg.c							 *
 *************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <gtk/gtk.h>
#include <GL/gl.h>
#include <GL/glu.h>
/*
#include <jpeglib.h>
#include <jerror.h>
*/

#ifdef EspUseDevil
	#include <IL/il.h> /* devIL */
	#include <IL/ilut.h>
#endif

#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"

#include "../include/main.h"
#include "../include/LibImg.h"

static int is_power_of_two(unsigned int number)
{
	return (number & (number - 1)) == 0;
}

#ifdef EspUseSDL
GLuint Img2Tex_SDL(char *name,
                    GLenum mag, GLenum min,
                    GLenum wrap_s, GLenum wrap_t)
{
	/*int w, h;
	Uint32 saved_flags;
	Uint8  saved_alpha;
	SDL_Surface *image;
	SDL_Rect 	 area;
	SDL_Rect 	 area2;*/
	
	GLuint texture_ID;
	SDL_Surface *TempSurface1;

	/*GLfloat texcoord[4]      ;-*/
	
    #ifdef DEBUG_IMGLIB
        g_print ("LOG::ImgLib.c::Img2Tex_SDL: Using SDL_image\n");
		g_print ("LOG-ImgLib.c :: Img2Tex %s\n",name);
	#endif
	TempSurface1 = IMG_Load(name);
	if(!TempSurface1) 
	{
			printf("LOG::ImgLib.c::Img2Tex_SDL: %s\n", IMG_GetError());
		// handle error
		return 0;
	}
	#ifdef DEBUG_IMGLIB
		g_print ("LOG-ImgLib.c :: TempSurface1.format.BitsPerPixel %i\n",TempSurface1->format->BitsPerPixel);
	#endif
	if (!is_power_of_two(TempSurface1->w) || !is_power_of_two(TempSurface1->h))
	{
		#ifdef DEBUG_IMGLIB
			g_print("LOG::ImgLib.c::Img2Tex_SDL: Texture non power of two\n");
			g_print("LOG::ImgLib.c::Img2Tex_SDL: Recalculate new regular picture\n");
		#endif
		/**TODO Stretching the surface for driver that not support non power of two texture**/
		/*w = power_of_two(TempSurface1->w);
		h = power_of_two(TempSurface1->h);

		image = SDL_CreateRGBSurface(
				SDL_SWSURFACE,
				w, h,
				32,
		#if SDL_BYTEORDER == SDL_LIL_ENDIAN
					0x000000FF,
					0x0000FF00,
					0x00FF0000,
					0xFF000000
		#else
					0xFF000000,
					0x00FF0000,
					0x0000FF00,
					0x000000FF
		#endif
				   );
		if ( image == NULL ) {
			return 0;
		}
		// Save the alpha blending attributes
		saved_flags = TempSurface1->flags&(SDL_SRCALPHA|SDL_RLEACCELOK);
		saved_alpha = TempSurface1->format->alpha;
		if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
			SDL_SetAlpha(TempSurface1, 0, 0);
		}

		// Copy the surface into the GL texture image
		area.x = 0;
		area.y = 0;
		area.w = TempSurface1->w;
		area.h = TempSurface1->h;
		area2.x = 0;
		area2.y = 0;
		area2.w = w;
		area2.h = h;
		g_print("LOG::ImgLib.c::Img2Tex_SDL: area.w->%i area.h->%i w->%i h->%i\n",area.w,area.h,w,h);
		//SDL_BlitSurface(TempSurface1, &area, image, &area2);
		SDL_StretchSurfaceBlit(TempSurface1, &area,image, &area2);
		// Restore the alpha blending attributes 
		if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
			SDL_SetAlpha(TempSurface1, saved_flags, saved_alpha);
		}

		// Create an OpenGL texture for the image
		glGenTextures(1, &texture_ID);
		glBindTexture(GL_TEXTURE_2D, texture_ID);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		g_print("LOG::ImgLib.c::Img2Tex_SDL: w->%i h->%i image->w %i image->h %i\n",w,h,image->w,image->h);
		glTexImage2D(GL_TEXTURE_2D,
				 0,
				 GL_RGBA,
				 w, h,
				 0,
				 GL_RGBA,
				 GL_UNSIGNED_BYTE,
				 image->pixels);
		SDL_FreeSurface(TempSurface1);
		SDL_FreeSurface(image); 
		return texture_ID;	*/
		
	}
	#ifdef DEBUG_IMGLIB
		g_print("LOG::ImgLib.c::Img2Tex_SDL: Texture power of two\n");
	#endif
	// Have OpenGL generate a texture object handle for us
	glGenTextures( 1, &texture_ID );
 
	// Bind the texture object
	glBindTexture( GL_TEXTURE_2D, texture_ID );
 
	// Set the texture's stretching properties
	if( mag!=0 ) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, mag);
	if( min!=0 ) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, min);
	if( wrap_s!=0) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, wrap_s);
	if( wrap_t!=0) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, wrap_t);
 
	// Edit the texture object's image data using the information SDL_Surface gives us
	glTexImage2D( GL_TEXTURE_2D, 0, (TempSurface1->format->BitsPerPixel==32)?(GL_RGBA):(GL_RGB), TempSurface1->w, TempSurface1->h, 0,
                      (TempSurface1->format->BitsPerPixel==32)?(GL_RGBA):(GL_RGB), GL_UNSIGNED_BYTE, TempSurface1->pixels );
	

	SDL_FreeSurface(TempSurface1);
	return texture_ID;
}
#endif

/**LIBDevil**/
//mytexture = load_texture("img.png", GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);
#ifdef EspUseDevil
GLuint Img2Tex_DEV(char *name,
                    GLenum mag, GLenum min,
                    GLenum wrap_s, GLenum wrap_t)
{
	GLuint texture_ID;
    #ifdef DEBUG_IMGLIB
        g_print ("Jukebox3D :: Using libdevil\n");
        g_print ("LOG-ImgLib.c :: Img2Tex %s\n",name);
	#endif
 	ilInit();
	ILenum error = ilLoadImage(name);
	if(error == IL_FALSE)
	{
		//ERROR << "ilLoadImage : error 0x" << std::hex << ilGetError() << ENDL;
		return 0;
	}

	ILint width = ilGetInteger(IL_IMAGE_WIDTH);
	ILint height = ilGetInteger(IL_IMAGE_HEIGHT);
//	ILint type = ilGetInteger(IL_IMAGE_TYPE); /* matches OpenGL */
//	ILint format= ilGetInteger(IL_IMAGE_FORMAT); /* matches OpenGL */
	//INFO << name << " : " << width << "x" << height << "x" << bpp << ENDL;

	if (!is_power_of_two(width) || !is_power_of_two(height))
	{
		//WARNING << "The image is not a power-of-two picture" << ENDL;
	}
	/*ILubyte *image_buffer = ilGetData();*/
 	
	glGenTextures(1, &texture_ID);

	glBindTexture(GL_TEXTURE_2D, texture_ID);

	glGetError(); // clear error
	ilutGLTexImage(0);
/*
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, format, type, image_buffer);
	if( glGetError() != GL_NO_ERROR )
	{
		//ERROR << "Can't build texture" << ENDL;
		return 0;
	}
*/
	if( mag!=0 ) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, mag);
	if( min!=0 ) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, min);
	if( wrap_s!=0) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, wrap_s);
	if( wrap_t!=0) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, wrap_t);

	return texture_ID;
}
#endif
