/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            LibOgl.c							 *
 *************************************************/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gtk/gtkgl.h>

#include <GL/gl.h>
#include <GL/glu.h>

#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"

#include "../include/main.h"
#include "../include/timer.h"
#include "../include/LibImg.h"
#include "../include/LibOgl.h"
#include "../include/managecfg.h"
#include "../include/interface_ogl.h"
/* Quick utility function for texture creation */
static int
power_of_two             ( int input          ){
	int value = 1;

	while ( value < input ) {
		value <<= 1;
	}
	return value;
}
void AddNewGLObject(void)
{
    int iFor;
	char sTemp[256];
	#ifdef DEBUG_OGLLIB
		g_print ("LOG-OglLib.c::AddNewGLObject: Loading texture for object %i.\n",OglScene->iNbrEntryObj+RESERVED_OBJECT);
	#endif


	//Detect if the new album is in the archive
    for (iFor = 0; iFor <OglScene->iNbrEntryObj ; iFor++)
 	{
        if (strcmp(OglObject[iFor+RESERVED_OBJECT].sPath,OglScene->CurrentPlay)==0)
        {
			#ifdef DEBUG_OGLLIB
				g_print ("LOG-OglLib.c::AddNewGLObject: Already in archive.\n");
			#endif
            OglScene->__iCurrentPlay__=iFor+RESERVED_OBJECT;
			/**Refresh position if the current have moved**/
			OglObject[iFor+RESERVED_OBJECT].x      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].x;
			OglObject[iFor+RESERVED_OBJECT].y      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].y;
			OglObject[iFor+RESERVED_OBJECT].z      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].z;
            return;
        }

 	}
	
	strcpy(sTemp,j3denv->__sDataPath__);
	/**TODO**/
	strcat(sTemp,"data/logo.png");
		   
	if (strcmp(OglScene->CurrentPlay,sTemp)==0)
		{
			OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].hidden=1;
		}

	/*#ifdef DEBUG_OGLLIB
		g_print("LOG-OglLib.c: Slot %d: - Value: %d\n", i, p[i]);
	#endif*/

    /*OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].hTexture = Img2Tex_DEV((char *) OglScene->sCheminA, GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);*/
	OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].hTexture = Img2Tex_SDL((char *) OglScene->CurrentPlay, GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

    strncpy(OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].sPath,
                            OglScene->CurrentPlay,
                            strlen(OglScene->CurrentPlay));

    OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].sPath[strlen(OglScene->CurrentPlay)] = '\0';
    OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].fAngle =  OglObject[OglScene->__iCurrentPlay__].fAngle;

    if (OglScene->iNbrEntryObj+RESERVED_OBJECT!=RESERVED_OBJECT)
    {
        OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].x      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].x;
        OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].y      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].y;
        OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].z      =  OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT-1].z;
    }

    /*else{
        OglObject[RESERVED_OBJECT].x      =  -1.2;
        OglObject[RESERVED_OBJECT].y      =  1.8;
        OglObject[RESERVED_OBJECT].z      =  0.0;


    }*/
	#ifdef DEBUG_OGLLIB
		g_print ("LOG-OglLib.c::AddNewGLObject: Copying path  %s.\n",OglObject[OglScene->iNbrEntryObj+RESERVED_OBJECT].sPath);
	#endif

    OglScene->__iCurrentPlay__=OglScene->iNbrEntryObj+RESERVED_OBJECT;
    OglScene->iNbrEntryObj=OglScene->iNbrEntryObj+1;
 return;
}
// Check OpenGL Version
int checkVersion(void)
{
  char *version = (char*)glGetString(GL_VERSION);
  char *vendor = (char*)glGetString(GL_VENDOR);
  char *renderer = (char*)glGetString(GL_RENDERER);
  char *exts = (char*)glGetString(GL_EXTENSIONS);

  g_print("OpenGL: %s\n", version);
  g_print("Vendor: %s\n", vendor);
  g_print("Renderer: %s\n", renderer);
  g_print("\n");

  if (!strstr(exts,"GL_ARB_texture_non_power_of_two"))
  {
    g_print("Extension not available::GL_ARB_texture_non_power_of_two\n");
    g_print("Jukebox3D warning, video card driver uncomplete.\n");
    g_print("Jukebox3D will work with ATI driver, but segfault with MESA driver.\n");
    return 0;
  }
  return 1;
}

void LdToolbar(char * skin)
{
    /*float fYmax,fXmax;*/
    char sPath[256];
    char sPathPlay[256];
    char sPathStop[256];
    char sPathPrev[256];
    char sPathNext[256];
    /*char sPathPaus[256];*/
	
	strcpy(sPath,skin);
	#ifdef DEBUG_OGLLIB
		g_print ("LOG-OglLib.c::LdToolbar: Loading skin for toolbar -> %s\n",sPath);
	#endif

    strcpy(sPathPlay,sPath);
   /* sPathPlay[strlen(sPath)]='\0';*/
    strcat(sPathPlay,"/play.png");
    /*sPathPlay[strlen(sPathPlay)]='\0';*/

    strcpy(sPathStop,sPath);
    /*sPathStop[strlen(sPath)]='\0';*/
    strcat(sPathStop,"/stop.png");
    /*sPathStop[strlen(sPathStop)]='\0';*/

    strcpy(sPathPrev,sPath);
    /*sPathPrev[strlen(sPath)]='\0';*/
    strcat(sPathPrev,"/prev.png");
    /*sPathPrev[strlen(sPathPrev)]='\0';*/

    strcpy(sPathNext,sPath);
    /*sPathNext[strlen(sPath)]='\0';*/
    strcat(sPathNext,"/next.png");
    /*sPathNext[strlen(sPathNext)]='\0';*/

    /*strcpy(sPathPaus,sPath);
    sPathPaus[strlen(sPath)]='\0';
    strcat(sPathPaus,"/pause.png");
    sPathPaus[strlen(sPathPaus)]='\0';*/

	
	#ifdef EspUseDEVIL
		glDeleteTextures(1,&j3dtb->Play);
    	j3dtb->Play = Img2Tex_DEV(sPathPlay , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Stop);
		j3dtb->Stop = Img2Tex_DEV(sPathStop , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Next);
		j3dtb->Next = Img2Tex_DEV(sPathNext , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Prev);
		j3dtb->Prev = Img2Tex_DEV(sPathPrev , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		/*glDeleteTextures(1,&ptTexPaus);
		ptTexPaus = Img2Tex_DEV(sPathPaus , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);*/
	#endif
	#ifdef EspUseSDL
		glDeleteTextures(1,&j3dtb->Play);
    	j3dtb->Play = Img2Tex_SDL(sPathPlay , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Stop);
		j3dtb->Stop = Img2Tex_SDL(sPathStop , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Next);
		j3dtb->Next = Img2Tex_SDL(sPathNext , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		glDeleteTextures(1,&j3dtb->Prev);
		j3dtb->Prev = Img2Tex_SDL(sPathPrev , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);

		/*glDeleteTextures(1,&ptTexPaus);
		ptTexPaus = Img2Tex_SDL(sPathPaus , GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP_TO_EDGE,GL_CLAMP_TO_EDGE);*/
	#endif
 return;
}


GLuint
SDL_GL_LoadTexture       ( SDL_Surface *surface,
						   GLfloat *texcoord  ){
	GLuint texture;
	int w, h;
	SDL_Surface *image;
	SDL_Rect area;
	Uint32 saved_flags;
	Uint8  saved_alpha;

	/* Use the surface width and height expanded to powers of 2 */
	w = power_of_two(surface->w);
	h = power_of_two(surface->h);
	texcoord[0] = 0.0f;			/* Min X */
	texcoord[1] = 0.0f;			/* Min Y */
	texcoord[2] = (GLfloat)surface->w / w;	/* Max X */
	texcoord[3] = (GLfloat)surface->h / h;	/* Max Y */

	image = SDL_CreateRGBSurface(
			SDL_SWSURFACE,
			w, h,
			32,
    #if SDL_BYTEORDER == SDL_LIL_ENDIAN /* OpenGL RGBA masks */
                0x000000FF,
                0x0000FF00,
                0x00FF0000,
                0xFF000000
    #else
                0xFF000000,
                0x00FF0000,
                0x0000FF00,
                0x000000FF
    #endif
		       );
	if ( image == NULL ) {
		return 0;
	}

	/* Save the alpha blending attributes */
	saved_flags = surface->flags&(SDL_SRCALPHA|SDL_RLEACCELOK);
	saved_alpha = surface->format->alpha;
	if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
		SDL_SetAlpha(surface, 0, 0);
	}

	/* Copy the surface into the GL texture image */
	area.x = 0;
	area.y = 0;
	area.w = surface->w;
	area.h = surface->h;
	SDL_BlitSurface(surface, &area, image, &area);

	/* Restore the alpha blending attributes */
	if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
		SDL_SetAlpha(surface, saved_flags, saved_alpha);
	}

	/* Create an OpenGL texture for the image */
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_2D, texture);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D,
		     0,
		     GL_RGBA,
		     w, h,
		     0,
		     GL_RGBA,
		     GL_UNSIGNED_BYTE,
		     image->pixels);
	SDL_FreeSurface(image); /* No longer needed */

	return texture;
}
/**2D Text and image displaying in opengl context**/
void ConfigureText       ( GtkWidget *wOgl               ){
	TTF_Font *font;
	char     *tmpfontsponsors;
	int renderstyle;
	GLfloat texcoord2[4];
	SDL_Color *forecol;
	SDL_Color *backcol;
	int ptsize;
	SDL_Color white = { 0xFF, 0xFF, 0xFF, 0 };
	SDL_Color black = { 0x00, 0x00, 0x00, 0 };
	SDL_Surface *text1=NULL;

    if( OglScene->__alive__ == TRUE)
    {
	/**We want relative ratio for text pos, virtual grid of 10 is used**/
	float fColumnSizeX=(wOgl->allocation.width)/10.0;
	float fColumnSizeY=(wOgl->allocation.height)/10.0;
	/**PLANTOGENE ??**/
	float fTextY=OglObject[2].y*fColumnSizeY;
	float fTextX=OglObject[2].x*fColumnSizeX;
	/*SDL_Surface *Temp_s=NULL;*/
	enum {
		RENDER_LATIN1,
		RENDER_UTF8,
		RENDER_UNICODE
	} rendertype;
	int ptScan=0;

	/* Initialize the TTF library */
	if ( TTF_Init() < 0 ) {
		fprintf(stderr, "TTF_ERROR: %s\n",SDL_GetError());
		return;
	}

	#ifdef DEBUG_OGLPAN
		g_print("LOG-OglPanel.c: Configuration du texte \n");
	#endif
	/*allocation memoire pour le stockage temporaire des infos*/
	/*TmpDataSpon=malloc(sizeof(TmpSpon)*eSportsScene.iNbrEntrySpon );*/

	renderstyle = TTF_STYLE_NORMAL;
	rendertype = RENDER_LATIN1;

	/* Default is black and white */
	forecol = &black;
	backcol = &white;

	tmpfontsponsors = malloc((99+1)*sizeof(char));

	if (tmpfontsponsors==NULL) {
		printf("Erreur d'allocation memoire.\n");
		exit(1);
	}

	ptsize = font_struct->iFontSize;

	strcpy(tmpfontsponsors,j3denv->__sDataPath__);
    tmpfontsponsors[strlen(tmpfontsponsors)]='\0';
	strcat(tmpfontsponsors,"fonts/");
    tmpfontsponsors[strlen(tmpfontsponsors)]='\0';

	strcat(tmpfontsponsors,font_struct->cFontPath);
    #ifdef DEBUG_OGLPAN
	/*	g_print("LOG-OglPanel.c::Configure text: tmpfontsponsors -> %s \n",tmpfontsponsors);*/
    #endif
	font = TTF_OpenFont(tmpfontsponsors, ptsize);

	if ( font == NULL ) {
		fprintf(stderr, "Couldn't load %d pt font: %s\n",
				ptsize, SDL_GetError());
	}

	TTF_SetFontStyle(font, renderstyle);
	/*g_print("iNbrEntrySpon: %i \n",OglScene->iNbrEntrySpon);*/
	if (OglScene->iNbrEntrySpon>0)
	{

		while (ptScan<OglScene->iNbrEntrySpon)
		{
			#ifdef DEBUG_OGLPAN
			/*	g_print("LOG-OglPanel.c: un tour de manivelle \n");
				g_print("LOG-OglPanel.c: ptScan: %i\n",ptScan);*/
			#endif
			if (DataTxtEntry[ptScan].type!=1)
			{
				int i;
				DataTxtEntry[ptScan].red   = font_struct->red   ;
				DataTxtEntry[ptScan].green = font_struct->green ;
				DataTxtEntry[ptScan].blue  = font_struct->blue  ;
				for(i=0 ; i<5 ; i++) // each message (1 to  5)
				{
					if(DataTxtEntry[ptScan].cMsg[i].cMessage)
					{
						#ifdef DEBUG_OGLPAN
						g_print("LOG-OglPanel.c: Message 1 -> %s\n",DataTxtEntry[ptScan].cMsg[i].cMessage);
						#endif
						if (strcmp(DataTxtEntry[ptScan].cMsg[i].cMessage, "") != 0)
						{
							#ifdef DEBUG_OGLPAN
							/*	g_print("LOG-OglPanel.c: Message non vide\n");*/
							#endif
							text1 = TTF_RenderUTF8_Blended(font, DataTxtEntry[ptScan].cMsg[i].cMessage, *backcol);

						}else{
							#ifdef DEBUG_OGLPAN
							/*	g_print("LOG-OglPanel.c: Message vide\n");*/
							#endif
							text1 = TTF_RenderUTF8_Blended(font, "      ", *backcol);

						}
						/**LeftRight**/
                        #ifdef DEBUG_OGLPAN
                        /*    g_print("LOG-OglPanel.c: Configuration du texte OglObject[2].x: %f OglObject[2].y: %f CX: %f CY: %f fColumnSizeX: %f fColumnSizeY:%f\n",OglObject[2].x,OglObject[2].y,fTextX,fTextY,fColumnSizeX,fColumnSizeY);*/
                        #endif
						/*DataTxtEntry[ptScan].cMsg[i].cX = OglObject[2].x+(wOptions->allocation.width - text1->w)/2;*/

						switch(font_struct->iTextAlign)
						{
                            case 0:
                                DataTxtEntry[ptScan].cMsg[i].cX = fTextX;/*-(text1->w/2);*/
                                break;
                            case 1:
                                DataTxtEntry[ptScan].cMsg[i].cX = fTextX-text1->w;
                                /*DataTxtEntry[ptScan].cMsg[i].cX = wOptions->allocation.width-fTextX;*//*-(text1->w/2);*/
                                break;
                            case 2:
                                DataTxtEntry[ptScan].cMsg[i].cX = fTextX+(wOgl->allocation.width - text1->w)/2;
                                break;
                            default:
                                DataTxtEntry[ptScan].cMsg[i].cX = fTextX;/*-(text1->w/2);*/
                                break;
						}

						/**UpDown**/
						/*DataTxtEntry[ptScan].cMsg[i].cY = OglObject[2].y+(wOptions->allocation.height - text1->h)/2+(OglScene->__iSpaceLine__*(i-1))-100;*/
						DataTxtEntry[ptScan].cMsg[i].cY = fTextY+(font_struct->iSpaceLine*(i-1))-100;
						DataTxtEntry[ptScan].cMsg[i].cW = text1->w;
						DataTxtEntry[ptScan].cMsg[i].cH = text1->h;
						DataTxtEntry[ptScan].cMsg[i].cTexture=SDL_GL_LoadTexture(text1, texcoord2);
                        #ifdef DEBUG_OGLPAN
                         /*   g_print("LOG-OglPanel.c: Configuration du texte CX: %d CY: %d\n",DataTxtEntry[ptScan].cMsg[i].cX,DataTxtEntry[ptScan].cMsg[i].cY);*/
                        #endif
						/* Make texture coordinates easy to understand (maybe)*/
						/**
						texMinX = texcoord[0];
						texMinY = texcoord[1];
						texMaxX = texcoord[2];
						texMaxY = texcoord[3];
											**/
						DataTxtEntry[ptScan].cMsg[i].cTexcoord[0] = texcoord2[0];
						DataTxtEntry[ptScan].cMsg[i].cTexcoord[1] = texcoord2[1];
						DataTxtEntry[ptScan].cMsg[i].cTexcoord[2] = texcoord2[2];
						DataTxtEntry[ptScan].cMsg[i].cTexcoord[3] = texcoord2[3];
					}
				}

			}else{
				//If image
				if(DataTxtEntry[ptScan].cMsg[0].cMessage)
				{
					#ifdef DEBUG_OGLPAN
					/*	g_print("LOG-OglPanel.c: Image 1 -> %s\n",DataTxtEntry[ptScan].cMsg[0].cMessage);*/
					#endif
					if (strcmp(DataTxtEntry[ptScan].cMsg[0].cMessage, "") != 0)
					{
						/*text1 = TTF_RenderUTF8_Blended(font, DataTxtEntry[ptScan].cMessage1, *backcol);*/
						/*ConfigureLogo(ptScan);*/

						#ifdef DEBUG_OGLPAN
						/*	g_print ("LOG-OglPanel.c: Loading Logo Texture.\n");*/
						#endif
						/*DataTxtEntry[iPt].cM1texture = LoadJpegTextures ((char *)DataTxtEntry[ptTexte].cMessage1);*/

						text1 = IMG_Load((char *)DataTxtEntry[ptScan].cMsg[0].cMessage);
						DataTxtEntry[ptScan].cMsg[0].cX = OglObject[2].x+(wOgl->allocation.width - text1->w)/2;
						DataTxtEntry[ptScan].cMsg[0].cY = OglObject[2].y+(wOgl->allocation.height - text1->h)/2;
						DataTxtEntry[ptScan].cMsg[0].cW = text1->w;
						DataTxtEntry[ptScan].cMsg[0].cH = text1->h;
                        DataTxtEntry[ptScan].red   = 1.0   ;
                        DataTxtEntry[ptScan].green = 1.0 ;
                        DataTxtEntry[ptScan].blue  = 1.0  ;
						#ifdef DEBUG_OGLPAN
						/*	g_print ("LOG-OglPanel.c: Texture width: %i, height: %i\n",DataTxtEntry[ptScan].cMsg[0].cW,DataTxtEntry[ptScan].cMsg[0].cH);*/
						#endif
						DataTxtEntry[ptScan].cMsg[0].cTexture=SDL_GL_LoadTexture(text1, texcoord2);
						/* Make texture coordinates easy to understand (maybe)*/
						/*texMinX = texcoord[0];
						texMinY = texcoord[1];
						texMaxX = texcoord[2];
						texMaxY = texcoord[3];*/
						DataTxtEntry[ptScan].cMsg[0].cTexcoord[0] = texcoord2[0];
						DataTxtEntry[ptScan].cMsg[0].cTexcoord[1] = texcoord2[1];
						DataTxtEntry[ptScan].cMsg[0].cTexcoord[2] = texcoord2[2];
						DataTxtEntry[ptScan].cMsg[0].cTexcoord[3] = texcoord2[3];

					}
				}
			}
			ptScan=ptScan+1;
		}
	}

	SDL_FreeSurface(text1);

	free(tmpfontsponsors);
    OglScene->__iInitTextEffect__=1;
    OglScene->fTextFade=0.0;
    /*fFadingStep=(60.0/fps)/100.0;*/
	}

	return;
}

 void
 gl_select(int x, int y,GtkWidget *widget)
 {
 	GLuint buff[64] = {0};
 	GLint hits, view[4];

 	/*
 		This choose the buffer where store the values for the selection data
 	*/
 	glSelectBuffer(64, buff);

 	/*
 		This retrieve info about the viewport
 	*/
 	glGetIntegerv(GL_VIEWPORT, view);

 	/*
 		Switching in selecton mode
 	*/
 	glRenderMode(GL_SELECT);

 	/*
 		Clearing the name's stack
 		This stack contains all the info about the objects
 	*/
 	glInitNames();

 	/*
 		Now fill the stack with one element (or glLoadName will generate an error)
 	*/
 	glPushName(0);

 	/*
 		Now modify the vieving volume, restricting selection area around the cursor
 	*/
 	glMatrixMode(GL_PROJECTION);
 	glPushMatrix();
 		glLoadIdentity();

 		/*
 			restrict the draw to an area around the cursor
 		*/
 		gluPickMatrix(x, y, 1.0, 1.0, view);
        gluPerspective(45.0f, widget->allocation.width/widget->allocation.height, 0.1f, 100.0f);
 		/*
 			Draw the objects onto the screen
 		*/
 		glMatrixMode(GL_MODELVIEW);

 		/*
 			draw only the names in the stack, and fill the array
 		*/

 		/**Borking things ?**/
 		draw_object(GL_SELECT,widget);

 		/*
 			Do you remeber? We do pushMatrix in PROJECTION mode
 		*/
 		glMatrixMode(GL_PROJECTION);
 	glPopMatrix();

 	/*
 		get number of objects drawed in that area
 		and return to render mode
 	*/
 	hits = glRenderMode(GL_RENDER);

 	/*
 		Print a list of the objects
 	*/
 	list_hits(hits, buff);

 	/*
 		uncomment this to show the whole buffer
 	* /
 	gl_selall(hits, buff);
 	*/

 	glMatrixMode(GL_MODELVIEW);
 }

void
list_hits(GLint hits, GLuint *names)
 {
     int i;
     int iTemp;
 	/*int i;


 		For each hit in the buffer are allocated 4 bytes:
 		1. Number of hits selected (always one,
 									beacuse when we draw each object
 									we use glLoadName, so we replace the
 									prevous name in the stack)
 		2. Min Z
 		3. Max Z
 		4. Name of the hit (glLoadName)
 	*/

        /*printf("%d hits:\n", hits);*/

        /*for (i = 0; i < hits; i++)
            printf(	"Number: %d\n"
                    "Min Z: %d\n"
                    "Max Z: %d\n"
                    "Name on stack: %d\n",
                    (GLubyte)names[i * 4],
                    (GLubyte)names[i * 4 + 1],
                    (GLubyte)names[i * 4 + 2],
                    (GLubyte)names[i * 4 + 3]
                    );*/
        OglScene->__LastClicked__=0;
        /**Hits var mean Max stack, we only analyse the first and second**/
        for (i = 0; i < 2; i++)
        {
            iTemp=(int)names[i * 4 + 3];
            if  ( iTemp>1 )
            {
                OglScene->__LastClicked__=iTemp;
                #ifdef DEBUG_OGLLIB
                    /*printf(	"LOG-OglLib.c::list_hits: eSportsScene.__LastClicked__ -> %d , %i\n",eSportsScene.__LastClicked__,hits);*/
                #endif
                if (i>1)
                {
                    break;
                }

            }
           /* if (hits==1)
            {
             eSportsScene.__LastClicked__=iTemp;
                #ifdef DEBUG_OGLLIB
                    printf(	"LOG-OglLib.c::list_hits: eSportsScene.__LastClicked__ -> %d , %i\n",eSportsScene.__LastClicked__,hits);
                #endif
             break;
            }

            iTemp=(int)names[i * 4 + 3];

            if (iTemp>=RESERVED_OBJECT)
             {
                eSportsScene.__LastClicked__=iTemp;
                #ifdef DEBUG_OGLLIB
                    printf(	"LOG-OglLib.c::list_hits: eSportsScene.__LastClicked__ -> %d , %i\n",eSportsScene.__LastClicked__,hits);
                #endif
                break;
             }

            if (iTemp!=0)
            {
                eSportsScene.__LastClicked__=iTemp;
                #ifdef DEBUG_OGLLIB
                    printf(	"LOG-OglLib.c::list_hits: eSportsScene.__LastClicked__ -> %d , %i\n",eSportsScene.__LastClicked__,hits);
                #endif
                break;
            }*/
               /* iTemp=(int)names[i * 4 + 3];
                eSportsScene.__LastClicked__=iTemp;
                #ifdef DEBUG_OGLLIB
                    printf(	"LOG-OglLib.c::list_hits: eSportsScene.__LastClicked__ -> %d , %i\n",eSportsScene.__LastClicked__,hits);
                #endif*/
        }

		switch (OglScene->__LastClicked__)
		{

		    case 8:
                #ifdef DEBUG_OGLLIB
                    g_print("Next track\n");
                #endif
                exec_pipe_command("next",j3denv->__sCurrentScript__);
                OglObject[5].fx=  1;
                ToolbarFx[5].fFxValue1  = 0.40 ;
                ToolbarFx[5].fFxValue2  = 1.00 ;
                /*iFXState1=4;*/
                break;
		    case 9:
                #ifdef DEBUG_OGLLIB
                    g_print("Previous track\n");
                #endif
                exec_pipe_command("prev",j3denv->__sCurrentScript__);
                OglObject[4].fx=  1;
                ToolbarFx[4].fFxValue1  = 0.40 ;
                ToolbarFx[4].fFxValue2  = 1.00 ;
                /*iFXState1=3;*/
                break;

		    case 6:
                #ifdef DEBUG_OGLLIB
                    g_print("play track\n");
                #endif
                exec_pipe_command("play",j3denv->__sCurrentScript__);
                OglObject[3].fx = 1   ;
                ToolbarFx[3].fFxValue1  = 0.40 ;
                ToolbarFx[3].fFxValue2  = 1.00 ;
                /*iFXState1=1;*/
                break;
		    case 7:
                #ifdef DEBUG_OGLLIB
                    g_print("stop track\n");
                #endif
                exec_pipe_command("stop",j3denv->__sCurrentScript__);
                OglObject[6].fx=  1;
                ToolbarFx[6].fFxValue1  = 0.40 ;
                ToolbarFx[6].fFxValue2  = 1.00 ;
                /*iFXState1=2;*/
                break;
            default:

                break;

		}
    return;
}

void
gl_selall(GLint hits, GLuint *buff)
 {
 	GLuint *p;
 	int i;

 	expose_event(NULL,NULL,NULL);

 	p = buff;
 	for (i = 0; i < 6 * 4; i++)
 	{
 		printf("LOG-OglLib.c: Slot %d: - Value: %d\n", i, p[i]);
 	}

 	printf("LOG-OglLib.c: Buff size: %x\n", (GLbyte)buff[0]);
 }

void
SDL_GL_Enter2DMode       ( GtkWidget * widget ){

	/* Note, there may be other things you need to change,
	   depending on how you have your OpenGL state set up.
	*/
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);

	/* This allows alpha blending of 2D textures with the scene */
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glViewport(0, 0, widget->allocation.width, widget->allocation.height);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glOrtho(0.0, (GLdouble)widget->allocation.width, (GLdouble)widget->allocation.height, 0.0, 0.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}

void
SDL_GL_Leave2DMode       ( GtkWidget * widget ){
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	glPopAttrib();
}
