/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            LibStr.c						 *
 *************************************************/
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "../include/main.h"
#include "../include/LibStr.h"
#ifdef G_OS_WIN32
	#define WIN32_LEAN_AND_MEAN 1
#endif

int GetFileName(char FilePath[MAX_LENGTH], char *tFileName)
{
	size_t i;
	i = strlen(FilePath);
	/*tFileName=malloc(sizeof(char)*strlen(FilePath));*/
	tFileName[0] = '\0';
	/*If we are on a win32 platform use \\ for detecting folder*/
	#ifdef WIN32_LEAN_AND_MEAN
		while(FilePath[i-1] != '\\')
	/*If we are on a Linux/unix platform use / for detecting folder*/
	#else
		while(FilePath[i-1] != '/')
	#endif
	{
		i--;
	}
	strcpy(tFileName,FilePath + i);
	#ifdef DEBUG
        g_print("LOG:StrLib.c::GetFileName: %s\n",tFileName);
	#endif
	return 0;
}
