/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            main.c							 *
 *************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <getopt.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <gtk/gtk.h>
#include <glade/glade.h>

#include "../include/main.h"
#include "../include/timer.h"
#include "../include/managecfg.h"
#include "../include/interface_main.h"

#include "../include/LibFile.h"

StrucTxtEntry    *DataTxtEntry    ;
MyOglScene       *OglScene        ;
EspEnvironment   *j3denv          ;
DynamicPicture   *QueryCover	  ;
MyGLObject	     *OglObject       ;
font_desc        *font_struct     ;
ToolbarSkin      *j3dtb           ;
FxStruct	     *ToolbarFx       ;

int 
InitEspEnv(void);
int 
PreInitMainScene(void);


/*Chargement de l'interface principal*/
int main(int argc, char *argv[])
{
	char *liste_options="d:f:";
	struct option longopts[]={
	/*name		has_arg		flag		val		**/
	{"nogui",		0,		NULL,		'n'	},
	};
	int longindex;
	int option;
	
	printf("------------------Jukebox3D----------------\n");
	printf("---------http://j3d.linuxonfire.org--------\n");
	printf("--------------------0.5.0------------------\n");
    #ifdef DEBUG_MAIN
        printf("LOG-main.c::main: Jukebox3D START\n");
    #endif
	//Allocate memory
	DataTxtEntry    = malloc(sizeof(StrucTxtEntry) * MAX_ENTRY);
	OglObject       = malloc(sizeof(MyGLObject)    * MAX_OBJECT) ;
	OglScene        = malloc(sizeof(MyOglScene)    * 1) ;
	j3denv			= malloc(sizeof(EspEnvironment)* 1) ;
	font_struct     = malloc(sizeof(font_desc)     * 1) ;	
	QueryCover      = malloc(sizeof(DynamicPicture)* 1) ;
	j3dtb           = malloc(sizeof(ToolbarSkin)   * 1) ;
	ToolbarFx       = malloc(sizeof(FxStruct)      * 1) ;
	/*espGui          = malloc(sizeof(GuiWinStack)   * 4) ;*/
	/*PreInitMainScene();*/
	
	
	InitEspEnv();
	PreInitMainScene();
	

	while ( (option = getopt_long(argc,argv,
					  liste_options,longopts,& longindex)) != -1){
						  
			switch (option) {
				
				case 'n' :
					printf("LOG-main.c::main.c: No gui start.\n");
				    OglScene->__only__ = 1    ;
					break;
			}
		}

	#ifdef DEBUG_MAIN
        /*printf("LOG-main.c::main: Home path -> %s\n",j3denv->__sHOME__    );*/
        printf("LOG-main.c::main: Data path -> %s\n"          ,j3denv->__sDataPath__       );
        printf("LOG-main.c::main: Skins path-> %s\n"          ,j3denv->__sTbSkin__         );
        printf("LOG-main.c::main: Current toolbar skin-> %s\n",j3denv->__sTbCurSkin__      );
        printf("LOG-main.c::main: Theme path-> %s\n"          ,j3denv->__sTheme__          );
        printf("LOG-main.c::main: Default Theme -> %s\n"      ,j3denv->__sDefaultTheme__   );
        printf("LOG-main.c::main: Current Theme -> %s\n"      ,j3denv->__sCurrentTheme__   );
        printf("LOG-main.c::main: GladeMain -> %s\n"          ,j3denv->__sGladeMain__      );
        printf("LOG-main.c::main: GladeOption -> %s\n"        ,j3denv->__sGladeOpt__       );
        printf("LOG-main.c::main: GladeOgl -> %s\n"           ,j3denv->__sGladeOgl__       );
		printf("LOG-main.c::main: Default script -> %s\n"     ,j3denv->__sCurrentScript__  );
        printf("LOG-main.c::main: XML Load\n"                                              );
    #endif
		
    gtk_init(&argc, &argv);
	xml_gui_load(j3denv->__sGladeMain__,"window1");
	
	//If exist read now
	timerHandler(0);
    //Read scene configuration
    ReadConfig(j3denv->__sHOME__        );
    ReadTheme (j3denv->__sCurrentTheme__);

    //Timer for reading configuration*
    installTimerEvents(1500);
    //Let's Go !
	gtk_main();
    #ifdef DEBUG_MAIN
        printf("LOG-main.c::main.c: free memory\n");
    #endif
	/**Free mallocated memory**/
	free( DataTxtEntry );
	free( OglObject    );
	free( OglScene     );
	free( j3denv       );
	free( j3dtb        );
	free( font_struct  );
	free( QueryCover   );
	free( ToolbarFx    );
	/*free( espGui       );*/
	return 0;
}

int 
InitEspEnv(void)
{
    int iResult=0;
	char sUberBuffer[256];
	char cToolBarBtn[96];
    /*j3denv.__sHOME__=getenv("HOME");*/
	
	char *sResult=getenv("J3DDPATH");
	if (sResult!=NULL)
	{
		//ENV SET--Building free desktop $XDG_CONFIG_HOME
		strcpy( j3denv->__sHOME__,g_get_user_config_dir());
		strcat( j3denv->__sHOME__,"/jukebox3D/");
    	strcpy( j3denv->__sDataPath__,getenv("J3DDPATH"));
    	strcpy( j3denv->__sGladeMain__,j3denv->__sDataPath__);
    	strcat( j3denv->__sGladeMain__,"data/interface.glade");
		strcpy( j3denv->__sGladeOpt__,j3denv->__sDataPath__);
		strcat( j3denv->__sGladeOpt__,"data/options.glade");
		strcpy( j3denv->__sGladeOgl__,j3denv->__sDataPath__);
		strcat( j3denv->__sGladeOgl__,"data/oglpanel.glade");

		//Theme path
		strcpy(j3denv->__sTheme__,j3denv->__sHOME__);
		strcat(j3denv->__sTheme__,"themes/");
		//Toolbar Skin path
		strcpy(j3denv->__sTbSkin__,j3denv->__sHOME__);
		strcat(j3denv->__sTbSkin__,"themes/TbSkins/");
		//Toolbar Default skins
		strcpy(j3denv->__sTbCurSkin__,j3denv->__sTbSkin__);
		strcat(j3denv->__sTbCurSkin__,"default");
		//Bg Skin path
		strcpy(j3denv->__sBgSkin__,j3denv->__sHOME__);
		strcat(j3denv->__sBgSkin__,"themes/BgSkins/");
		//Current bg Skin path
		strcpy(j3denv->__sBgCurSkin__,j3denv->__sBgSkin__);
		strcat(j3denv->__sBgCurSkin__,"");
		//Current cover path
		strcpy(j3denv->__sCoverPath__,j3denv->__sHOME__);
		strcat(j3denv->__sCoverPath__,"covers/");
		//Default theme
		strcpy(j3denv->__sDefaultTheme__,j3denv->__sTheme__);
		strcat(j3denv->__sDefaultTheme__,"default.j3d");
		//Current theme
		strcpy(j3denv->__sCurrentTheme__,j3denv->__sDefaultTheme__);
		
		/**j3d engine settings**/
		strcpy( j3denv->__sCurrentScript__ ,j3denv->__sDataPath__);
    	strcat( j3denv->__sCurrentScript__ , "scripts/amarok");
		
		//Anyway always try to create dir is more optimized than testing it :)
		mkdir(j3denv->__sHOME__,S_IRUSR | S_IWUSR | S_IXUSR);
		iResult=mkdir(j3denv->__sTheme__,S_IRUSR | S_IWUSR | S_IXUSR);
		if(iResult==0)
		{
			#ifdef DEBUG_MAIN
				g_print("LOG-main.c::main: First start j3d\n");
			#endif
				strcpy(sUberBuffer,j3denv->__sTheme__);
				strcat(sUberBuffer,"tower.j3d");
				/*g_print("LOG-main.c::main: %s\n",sUberBuffer);*/
				CopyFile("data/bundled/themes/tower.j3d",sUberBuffer);
			
				strcpy(sUberBuffer,j3denv->__sTheme__);
				strcat(sUberBuffer,"FunkyKing.j3d");
				/*g_print("LOG-main.c::main: %s\n",sUberBuffer);*/
				CopyFile("data/bundled/themes/FunkyKing.j3d",sUberBuffer);
			
				strcpy(sUberBuffer,j3denv->__sTheme__);
				strcat(sUberBuffer,"blackwhite.j3d");
				/*g_print("LOG-main.c::main: %s\n",sUberBuffer);*/
				CopyFile("data/bundled/themes/blackwhite.j3d",sUberBuffer);			
		}
		mkdir(j3denv->__sCoverPath__,S_IRUSR | S_IWUSR | S_IXUSR);
		iResult=mkdir(j3denv->__sTbSkin__,S_IRUSR | S_IWUSR | S_IXUSR);
		if(iResult==0)
		{
			#ifdef DEBUG_MAIN
				g_print("LOG-main.c::main: Creating skin folder\n");
			#endif
			mkdir(j3denv->__sTbCurSkin__,S_IRUSR | S_IWUSR | S_IXUSR);
			
			//Play button
			strcpy(cToolBarBtn,j3denv->__sTbSkin__ );
			strcat(cToolBarBtn,"default/play.png");
			CopyFile("skins/default/play.png",cToolBarBtn);
			//Stop button
			strcpy(cToolBarBtn,j3denv->__sTbSkin__ );
			strcat(cToolBarBtn,"default/stop.png");
			CopyFile("skins/default/stop.png",cToolBarBtn);		
			//Next button
			strcpy(cToolBarBtn,j3denv->__sTbSkin__ );
			strcat(cToolBarBtn,"default/next.png");
			CopyFile("skins/default/next.png",cToolBarBtn);			
			//Prev button
			strcpy(cToolBarBtn,j3denv->__sTbSkin__ );
			strcat(cToolBarBtn,"default/prev.png");
			CopyFile("skins/default/prev.png",cToolBarBtn);	
		}

		strcat(j3denv->__sHOME__,"jukebox3D.dat");
		j3denv->__sHOME__[strlen(j3denv->__sHOME__)]='\0';	
	}
	
return 0;	
}


int 
PreInitMainScene(void)
{
	/*OglScene.iCurrentPlay= malloc(sizeof(char)     * (999+1))          ;*/
	/*eSportsScene.sCheminB= malloc(sizeof(char)     * (999+1))          ;*/
    strcpy(OglScene->CurrentPlay,"data/logo.png");
    /*OglScene->CurrentPlay("data/logo.png")] = '\0';*/

	OglScene->iNbrEntrySpon      = 0    ;
	DataTxtEntry[OglScene->iNbrEntrySpon].type=0;
	/**main Scene pre-init **/
	OglScene->iNbrEntryObj       = 0    ;
	OglScene->__dColumnSize__    = 0.0  ;
	OglScene->__alive__          = FALSE;
	OglScene->__LiveTexRefresh__ = 0    ;
	OglScene->__model__          = 0    ;
	OglScene->__style_anim__     = 0    ;
	OglScene->__speed__          = 0.1  ;
	OglScene->__ActSpons__       = 0    ;
	OglScene->__UpdSpons__       = 0    ;
	OglScene->__fTimeSpons__     = 3.0  ;
	OglScene->__LastClicked__    = 0    ;
	OglScene->__iMode__		     = 0	;
	OglScene->__aWorldColor__[0] = 0.0  ;
    OglScene->__aWorldColor__[1] = 0.0  ;
    OglScene->__aWorldColor__[2] = 0.0  ;
    OglScene->__iInitTextEffect__= 0    ;
    OglScene->__iAlwaysDispInf__ = 1    ;
    OglScene->__iHideToolbar__   = 0    ;
    OglScene->__iCurrentPlay__   = RESERVED_OBJECT   ;
    OglScene->__iArchiveMode__   = 1    ;
    OglScene->__fCurPlaySize__   = 1.5  ;
    OglScene->__iActCurPlayRef__ = 0    ;
    OglScene->__iActArchRef__    = 1    ;
    OglScene->__fArchiveSize__   = 1.1  ;
    OglScene->__aArchivePos__[0] = 13.7 ;
    OglScene->__aArchivePos__[1] = 4.5  ;
    OglScene->__aArchivePos__[2] = 0.0  ;
	OglScene->__iFullScreen__ = 0  ;
    OglScene->__fGroundPos__=5.5;
	OglScene->ptTexte=0;
	
    /*OglScene->__aGroundPos__[0] = 6.0  ;*/
    OglScene->__fGroundPos__ = 5.5  ;
    /*OglScene->__aGroundPos__[2] = 0.0  ;*/
	
	QueryCover->enable=0;
	QueryCover->Pending=0;
    /**Init 3D engine for use fonts**/
    /**Init Line 1**/
	strcpy(DataTxtEntry[0].cMsg[0].cMessage," ");
	
    /**Init Line 2**/
	strcpy(DataTxtEntry[0].cMsg[1].cMessage," ");
	
    /**Init Line 3**/
	strcpy(DataTxtEntry[0].cMsg[2].cMessage," ");
	
    /**Init Line 4**/
	strcpy(DataTxtEntry[0].cMsg[3].cMessage," ");
	
    /**Init Line 5**/
	strcpy(DataTxtEntry[0].cMsg[4].cMessage," ");
	OglScene->__ActSpons__ =1;
	OglScene->iNbrEntrySpon=1;
	
    #ifdef DEBUG_MAIN
		g_print ("LOG-main.c: Generating default object position.\n");
	#endif

	/**Configure current playing model**/
    OglObject[RESERVED_OBJECT].x= 9.15;
    OglObject[RESERVED_OBJECT].y= 2.0;
    OglObject[RESERVED_OBJECT].z= 0.0;
	/**Configure Text/SPonsors Position**/
	OglObject[2].x= 0.5 ;
    OglObject[2].y= 2.5 ;
    OglObject[2].z= 0   ;

    /**Position background box **/
	OglObject[1].x= 4.3 ;
    OglObject[1].y=-9.6 ;
    OglObject[1].z= 0.0 ;
	OglObject[1].hidden=0;
	OglObject[1].red   =0.4;
	OglObject[1].green =0.4;
	OglObject[1].blue  =0.4;
	OglObject[1].fWidth =5.9;
	OglObject[1].fHeight=1.7;

    /**Configure Player Play**/
	OglObject[3].x =  5.9;
	OglObject[3].y = -7.9;
	OglObject[3].z =  0.0;
	OglObject[3].fx=  0;
	/**Configure Player Stop**/
	OglObject[4].x=OglObject[3].x+1;
	OglObject[4].y=OglObject[3].y;
	OglObject[4].z=OglObject[3].z;
	OglObject[4].fx=  0;
    /**Configure Player Prev**/
	OglObject[5].x=OglObject[3].x+2;
	OglObject[5].y=OglObject[3].y;
	OglObject[5].z=OglObject[3].z;
	OglObject[5].fx=  0;
	/**Configure Player Next**/
	OglObject[6].x=OglObject[3].x+3;
	OglObject[6].y=OglObject[3].y;
	OglObject[6].z=OglObject[3].z;
    OglObject[6].fx=  0;

	/**sponsors init**/
	strcpy(font_struct->cFontPath,"Vera.ttf");
	font_struct->iFontSize     = 28 ;
	font_struct->iSpaceLine    = 35 ;
    font_struct->red           = 1.0;
    font_struct->green         = 1.0;
    font_struct->blue          = 1.0;
    font_struct->iTextAlign    = 0  ;
return 1;	
}
