/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 /****************************************************************************/
 /**                    Managecfg.c                                          */
 /**                Managing esp engine config file                          */
 /**                Include Saving and restauring file                       */
 /****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <gtk/gtk.h>
#include <glade/glade-xml.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <string.h>

#include "../include/main.h"
#include "../include/language.h"
#include "../include/managecfg.h"
#include "../include/interface_ogl.h"
#include "../include/interface_main.h"

#include "../include/LibStr.h"
#include "../include/LibOgl.h"
#include "../include/LibCover.h"


#define BUFSIZE 256

int  iReadSponsors = 0; /** Parser flag for switching classical reading ( 1 key -> 1 Value to 1 key -> multiple value **/
int  iCurrentRead  = 0; /** Need to save current index for restoring sponsors data **/
int  iCurrentType  = 99; /** Need to save the current entry type for restoring data ( text or image )**/
int  iReadKeyNow   = 0;

void ReadInfo(int fd)
{
	char buffer[BUFSIZE];
	char sBuffer[BUFSIZE];
	char CleanLineBuffer[BUFSIZE];
	FILE *fIn;
    int iCurrent=0;
	int iNewCover=0;
	fIn = fdopen(fd, "r");

	/*if(fIn == NULL)
	{
		perror("fdopen");
		return;
	}*/

	int iNeedReconfigureText=0;
	
	if(fIn == NULL)
	{
		perror("fopen");
		return;
	}
	while(fgets(buffer, BUFSIZE, fIn)!=NULL)
	{
        switch(iCurrent)
                {
                    /**Line 0 mean cover**/
                    case 0:


							if (strlen(buffer) >1) 
							{
								/*strncpy(CleanLineBuffer,buffer,strlen(buffer));*/
								strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
								CleanLineBuffer[strlen(buffer)-1] = '\0';
								#ifdef DEBUG_CFG
									g_print("LOG-Managecfg.c: Buffer cover %s\n",CleanLineBuffer);
								#endif
								/*Amarok return a valid cover if the album have no cover**/
								/**-Little hack for detecting generic cover and try to search with libcover**/
								GetFileName(CleanLineBuffer,sBuffer);
								#ifdef DEBUG_CFG
										/*g_print("LOG-Managecfg.c: Detect amarok no cover %s\n",sBuffer);*/
								#endif
								if (strcmp(sBuffer,"130@nocover.png")!=0)
								{
									if(g_file_test(CleanLineBuffer, G_FILE_TEST_EXISTS))
									{
										if (strcmp(OglScene->CurrentPlay, CleanLineBuffer)!=0)
										{	

												strcpy(OglScene->CurrentPlay,CleanLineBuffer);
												#ifdef DEBUG_CFG
													/*g_print("LOG-Managecfg.c: Loaded new cover %s\n",OglScene->CurrentPlay);*/
												#endif
												
												QueryCover->Pending=0;
												QueryCover->TimeOut=0;
												iNewCover=0;
												AddNewGLObject();

										}else{
											#ifdef DEBUG_CFG
												g_print("LOG-Managecfg.c: Loading nothing\n");
											#endif										
										}									
										
									}else{
										
											#ifdef DEBUG_CFG
												g_print("LOG-Managecfg.c: Cover returned by player doesnt exist\n");
											#endif									
											iNewCover=1;
									}
								}else{
									#ifdef DEBUG_CFG
										g_print("LOG-Managecfg.c: Amarok return nocover\n");
									#endif									
									iNewCover=1;									
								}
							}else{
								/*strcpy(OglScene->CurrentPlay,j3denv->__sDataPath__);
								strcat(OglScene->CurrentPlay,"data/logo.png");
								//Add new object to the scene
								AddNewGLObject();*/
								#ifdef DEBUG_CFG
									g_print("LOG-Managecfg.c: Empty line 1 ( cover )\n");
								#endif
							}
                                #ifdef DEBUG_CFG
                                    g_print("LOG-Managecfg.c: OglScene->CurrentPlay -> %s\n",OglScene->CurrentPlay);
                                #endif
                        break;
                    /**Line 1 mean album viewed in second position**/
                    case 1:
                        #ifdef DEBUG_CFG
                            /*g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 1 ( album ) -> %s\n",buffer);*/
                        #endif
                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';
                        if (strcmp(buffer, "") != 0)
                            {
                                if (strcmp(DataTxtEntry[0].cMsg[1].cMessage, CleanLineBuffer)!=0)
                                {
                                    /**Init Line 1**/
                                    strncpy(DataTxtEntry[0].cMsg[1].cMessage,CleanLineBuffer,255);
									#ifdef DEBUG_CFG
										g_print("LOG-Managecfg.c::LoadAmarokInfo: Loaded new album -> %s\n",DataTxtEntry[0].cMsg[1].cMessage);
									#endif
                                    if (OglScene->__alive__)
                                    {
                                        iNeedReconfigureText=1;
										
                                    }
                                }
                            }
                        break;

                    /**Line 2 mean artist view in first**/
                    case 2:
                    	#ifdef DEBUG_CFG
                            g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 2 ( artiste ) -> %s\n",buffer);
                        #endif
                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';
                        if (strcmp(buffer, "") != 0)
                            {
									if (strcmp(DataTxtEntry[0].cMsg[0].cMessage, CleanLineBuffer)!=0)
									{
										strncpy(DataTxtEntry[0].cMsg[0].cMessage,CleanLineBuffer,255);
										#ifdef DEBUG_CFG
											g_print("LOG-Managecfg.c::LoadAmarokInfo: Loaded new artist -> %s\n",DataTxtEntry[0].cMsg[0].cMessage);
										#endif
										if (OglScene->__alive__)
										{
											iNeedReconfigureText=1;
										}
										#ifdef DEBUG_CFG
											g_print("LOG-Managecfg.c::LoadAmarokInfo: Default string\n");
										#endif
									}
                            }
                        break;

                    /**Current time**/
                    case 3:
                    	#ifdef DEBUG_CFG
                            g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 3 ( current time ) -> %s\n",buffer);
                        #endif
                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';
                        if (strcmp(buffer, "") != 0)
                            {
								#ifdef DEBUG_CFG
                                	g_print("Current time: %s\n",CleanLineBuffer);
								#endif
							}

                        break;

                    /**Line 4 mean style viewed in four**/
                    case 4:
                        #ifdef DEBUG_CFG
                            g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 4 ( style ) -> %s\n",buffer);
                        #endif


                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';
                        if (strcmp(buffer, "") != 0)
                            {
                                if (strcmp(DataTxtEntry[0].cMsg[3].cMessage, CleanLineBuffer)!=0)
                                {
                                    strncpy(DataTxtEntry[0].cMsg[3].cMessage,CleanLineBuffer,255);
									#ifdef DEBUG_CFG
										g_print("LOG-Managecfg.c::LoadAmarokInfo: Loaded new style -> %s\n",DataTxtEntry[0].cMsg[3].cMessage);
									#endif
                                }
                            }else{
                                    strcpy(DataTxtEntry[0].cMsg[3].cMessage,"");

                            }
                        break;
                    /**Line 5 mean title viewed in third**/
                    case 5:
                    	#ifdef DEBUG_CFG
                            /*g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 5 ( title ) -> %s\n",buffer);*/
                        #endif
                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';
                        if (strcmp(buffer, "") != 0)
                            {
                                if (strcmp(DataTxtEntry[0].cMsg[2].cMessage, CleanLineBuffer)!=0)
                                {
                                    strncpy(DataTxtEntry[0].cMsg[2].cMessage,CleanLineBuffer,255);
									#ifdef DEBUG_CFG
										g_print("LOG-Managecfg.c::LoadAmarokInfo: Loaded new title -> %s\n",DataTxtEntry[0].cMsg[2].cMessage);
									#endif
                                    if (OglScene->__alive__)
                                    {
                                        iNeedReconfigureText=1;
                                    }
                                }
                            }
                       /* g_print("Case 5::iNeedReconfigureText-> %i \n",iNeedReconfigureText);*/
                        break;
                    /**Total time**/
                    case 6:


                        break;
                    /**Year view in five ***/
                    case 7:
                    	#ifdef DEBUG_CFG
                            /*g_print("LOG-Managecfg.c::LoadAmarokInfo: Try loading line 6 ( year ) -> %s\n",buffer);*/
                        #endif
                        strncpy(CleanLineBuffer,buffer,strlen(buffer)-1);
                        CleanLineBuffer[strlen(buffer)-1] = '\0';

                        if (strcmp(buffer, "") != 0)
                            {
                            /*g_print("-------------------------NOT EMPTY-------------------------------\n");
                            g_print("---------------------------CleanLineBuffer-> %s \n",CleanLineBuffer);*/
                            if (strcmp(CleanLineBuffer, "0") != 0)
                                {
									if (strcmp(CleanLineBuffer,"Jukebox3D - Player enhancer")!=0)
                                	{
										if (strcmp(DataTxtEntry[0].cMsg[4].cMessage, CleanLineBuffer)!=0)
										{
											strncpy(DataTxtEntry[0].cMsg[4].cMessage,CleanLineBuffer,255);
											#ifdef DEBUG_CFG
												g_print("LOG-Managecfg.c::LoadAmarokInfo: Loaded new year -> %s\n",DataTxtEntry[0].cMsg[4].cMessage);
											#endif
											if (OglScene->__alive__)
											{
												iNeedReconfigureText=1;
											}
										}
									}

                                }else{
                                    strcpy(DataTxtEntry[0].cMsg[4].cMessage," ");
                                }
                            }else{
                            /*    g_print("-------------------------EMPTY YEAR-------------------------------\n");*/
                            }
                        break;
                    default:
                        break;
                }
                iCurrent=iCurrent+1;
	}
	
	/**Fin de recuperation d'info**/
	/*char *path;*/
	#ifdef DEBUG_CFG
		g_print("LOG::managecfg.c::ReadInfo: album->%s artiste->%s\n",DataTxtEntry[0].cMsg[1].cMessage,DataTxtEntry[0].cMsg[0].cMessage);
	#endif
	/*fetch_metadata(DataTxtEntry[0].cMsg[0].cMessage,DataTxtEntry[0].cMsg[1].cMessage,&path);*/
	#ifdef DEBUG_CFG
		printf("LOG:Managecfg.c::ReadInfo: %i\n",iNewCover);
	#endif	
    if (iNewCover==1)
    {
		if (QueryCover->Pending!=1)
		{
		#ifdef DEBUG_CFG
			printf("LOG:Managecfg.c::ReadInfo: Detecting if cover file exist\n");
		#endif			
			exec_cover(DataTxtEntry[0].cMsg[0].cMessage,DataTxtEntry[0].cMsg[1].cMessage);
			QueryCover->Pending=1;
            /*strcpy(OglScene->CurrentPlay,j3denv->__sDataPath__);
			strcat(OglScene->CurrentPlay,"data/logo.png");
			AddNewGLObject();*/
			strcpy(OglScene->CurrentPlay,j3denv->__sDataPath__);
			strcat(OglScene->CurrentPlay,"data/logo.png");
			AddNewGLObject();
		}
    }
    if (iNeedReconfigureText==1)
    {
            if (OglScene->__alive__)
            {
				#ifdef DEBUG_CFG
					g_print ("LOG:Managecfg.c::ReadInfo: Reconfigure text triggered\n");
				#endif
                ReConfigureText();
            }
        iNeedReconfigureText=0;
    }
	fclose(fIn);	
	
	/**Manage pending cover**/
	if (QueryCover->Pending==1)
	{
		if (QueryCover->TimeOut>5)
		{
			#ifdef DEBUG_CFG
				printf("LOG:Managecfg.c::ReadInfo: Cover not found\n");
			#endif		
			QueryCover->Pending=0;
			QueryCover->TimeOut=0;
			return;
		}
		gchar *url=NULL;
		gchar *artist = __cover_art_process_string(DataTxtEntry[0].cMsg[0].cMessage);
		gchar *album =  __cover_art_process_string(DataTxtEntry[0].cMsg[1].cMessage);
		url = g_strdup_printf("%s%s-%s.jpg", j3denv->__sCoverPath__, artist, album);
		#ifdef DEBUG_CFG
			printf("LOG:Managecfg.c::ReadInfo: Cover is ready ?\n");
		#endif	
		if(g_file_test(url, G_FILE_TEST_EXISTS)) {
			strcpy(OglScene->CurrentPlay,url);
			#ifdef DEBUG_CFG
				printf("Cover ready file downloaded: %s\n",OglScene->CurrentPlay);
			#endif
			g_free(url);
			g_free(artist);
			g_free(album);
			AddNewGLObject();
			QueryCover->Pending=0;
			QueryCover->TimeOut=0;
		}else{QueryCover->TimeOut++;}
	}
	
 return;
}


int ReadConfig(char *conf)
{
	char buffer[BUFSIZE];
	FILE *fIn;
    iCurrentType=99;

	fIn = fopen(conf, "r");
	if(fIn == NULL)
	{
        #ifdef DEBUG_CFG
            g_print("LOG-Managecfg.c::ReadConfig: First start generating config files\n");
        #endif
            CreateConfig(j3denv->__sHOME__);
		return 0;
	}

	while(fgets(buffer, BUFSIZE, fIn)!=NULL)
	{
		char *eq = strstr(buffer, "=");
		if(eq != NULL)
		{
			char *key;
			char *value;

			size_t keylen;
			size_t vallen;

			keylen = eq - buffer;

			key = (char*)malloc(sizeof(char) * (keylen + 1));
			strncpy(key, buffer,keylen);
			key[keylen] = '\0';

			vallen = strlen(eq+1/*=*/)-1/*\n*/;

			value = (char*)malloc(sizeof(char) * (vallen + 1));
			strncpy(value, eq+1, vallen);
			value[vallen] = '\0';

            LoadKey(key, value);

           /* if ((iReadSponsors==1) && (OglScene->iNbrEntrySpon>0))
            {
                #ifdef DEBUG_CFG
                    g_print("LOG-Managecfg.c: Mode Read sponsors \n");
                #endif
                if (iReadKeyNow==1)
                {
                    #ifdef DEBUG_CFG
                        g_print("LOG-Managecfg.c: Index -> %i Numero ligne -> %i Contenu -> %s\n",iCurrentRead,atoi(key),value);
                    #endif
                    //DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage= (char *) malloc((strlen(value)+1)*sizeof(char));
                    strncpy(DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage,value,255);
                    //strncpy(DataTxtEntry[iCurrentRead].label,(const char *)DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage,16);
                    if (iCurrentType==1)
                    {
                        iReadSponsors=0;
                        iCurrentRead=0;
                        iCurrentType=99;
                    }
                }
                if (iCurrentType!=99)
                {
                    iReadKeyNow=1;
                }
            }
*/

            #ifdef DEBUG_CFG
                printf("LOG-Managecfg.c: Key -> %s Value -> %s\n", key, value);
            #endif
			free(key);
			free(value);
		}
	}

	fclose(fIn);
	return EXIT_SUCCESS;
}


int ReadTheme(char *conf)
{
	char buffer[BUFSIZE];
	FILE *fIn;
    iCurrentType=99;

    #ifdef DEBUG_CFG
        g_print("LOG-Managecfg.c::ReadTheme: Reading theme -> %s\n",conf);
    #endif

	fIn = fopen(conf, "r"   );
	if(fIn == NULL)
	{
        #ifdef DEBUG_CFG
            g_print("LOG-Managecfg.c::ReadTheme: First start generating theme file\n");
        #endif
            CreateTheme(j3denv->__sCurrentTheme__);
		return 0;
	}

	while(fgets(buffer, BUFSIZE, fIn)!=NULL)
	{
		char *eq = strstr(buffer, "=");
		if(eq != NULL)
		{
			char *key;
			char *value;

			size_t keylen;
			size_t vallen;

			keylen = eq - buffer;

			key = (char*)malloc(sizeof(char) * (keylen + 1));
			strncpy(key, buffer,keylen);
			key[keylen] = '\0';

			vallen = strlen(eq+1/*=*/)-1/*\n*/;

			value = (char*)malloc(sizeof(char) * (vallen + 1));
			strncpy(value, eq+1, vallen);
			value[vallen] = '\0';

            LoadKey(key, value);

            /*if ((iReadSponsors==1) && (OglScene->iNbrEntrySpon>0))
            {
                #ifdef DEBUG_CFG
                    g_print("LOG-Managecfg.c: Mode Read sponsors \n");
                #endif
                if (iReadKeyNow==1)
                {
                    #ifdef DEBUG_CFG
                        g_print("LOG-Managecfg.c: Index -> %i Numero ligne -> %i Contenu -> %s\n",iCurrentRead,atoi(key),value);
                    #endif
                    //DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage= (char *) malloc((strlen(value)+1)*sizeof(char));
                    strncpy(DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage,value,255);
                    //strncpy(DataTxtEntry[iCurrentRead].label,(const char *)DataTxtEntry[iCurrentRead].cMsg[atoi(key)].cMessage,16);
                    if (iCurrentType==1)
                    {
                        iReadSponsors=0;
                        iCurrentRead=0;
                        iCurrentType=99;
                    }
                }
                if (iCurrentType!=99)
                {
                    iReadKeyNow=1;
                }
            }*/


            #ifdef DEBUG_CFG
                printf("LOG-Managecfg.c: Key -> %s Value -> %s\n", key, value);
            #endif
			free(key);
			free(value);
		}
	}

	fclose(fIn);
	return EXIT_SUCCESS;
}


int CreateConfig( char *conf )
{
	FILE *fichier      ;         /*    pointeur vers un type fichier    */
	char CheckConf[128];
	/*int ptScan=0;
	int i=0;*/

	/*ptr_pos = strstr (conf, ".");

	if (ptr_pos==NULL)
	{
		strncpy(CheckConf, conf, strlen(conf)+1);
		strncat(CheckConf, ".esp", 5);
		#ifdef DEBUG_CFG
			printf( "LOG-Managecfg.c: Adding ESP Ext File name -> %s \n", CheckConf);
		#endif
	}else{
		strncpy(CheckConf, conf, strlen(conf)+1);
		#ifdef DEBUG_CFG
			printf( "LOG-Managecfg.c: ESP ext already here File name -> %s \n", CheckConf);
		#endif
	}*/
	strcpy(CheckConf, conf);
	CheckConf[strlen(CheckConf)]='\0';

	fichier = fopen (CheckConf, "wt") ;          /*    ouverture du fichier 'mon_fichier.txt'    */
												 /*    pour ecriture (w) en mode texte (t)       */

	if (fichier == NULL)                         /*    test de reussite                     */
	{                                            /*    le pointeur n'est pas valide => stop */
		printf (ERRSAVE) ;                       /*    message d'alerte                     */
		exit (0) ;                               /*    terminer le programme                */
	}
	#ifdef DEBUG_CFG
		g_print("LOG-Managecfg.c: Start writing configuration\n");
	#endif
	fprintf (fichier,"/*Jukebox3D save file*/\n"                             );
	fprintf (fichier,"OglScene->CurrentPlay=%s\n", OglScene->CurrentPlay     ); 
	fprintf (fichier,"J3DScript=%s\n"            , j3denv->__sCurrentScript__); 
	fprintf (fichier,"CurrentTheme=%s\n"         , j3denv->__sCurrentTheme__ ); 

	/*if (OglScene->__ActSpons__==1)
	{
		if (OglScene->iNbrEntrySpon>0)
		{
			while (ptScan<OglScene->iNbrEntrySpon)
			{
				#ifdef DEBUG_CFG
					g_print("LOG-Managecfg.c: DO WHILE BLOC ENTRY\n");
					g_print("LOG-Managecfg.c: Current ptScan: %i\n",ptScan);
				#endif
				if (DataTxtEntry[ptScan].type!=1)
				{
					i=0;
					fprintf (fichier,"LineID=%i\n",ptScan);
					fprintf (fichier,"LineType=%i\n",DataTxtEntry[ptScan].type);

					for(i=0 ; i<5 ; i++) // pour chaque message (1 a  5)
					{
						if(DataTxtEntry[ptScan].cMsg[i].cMessage)
						{
							if (strcmp(DataTxtEntry[ptScan].cMsg[i].cMessage, "") != 0)
							{
								#ifdef DEBUG_CFG
									g_print("LOG-Managecfg.c: Ecriture du texte -> %s\n",DataTxtEntry[ptScan].cMsg[i].cMessage);
								#endif
								fprintf (fichier,"%i=%s\n",i, DataTxtEntry[ptScan].cMsg[i].cMessage) ;
							}
						}
					}

				}else{
					//If image
					if(DataTxtEntry[ptScan].cMsg[0].cMessage)
					{
						#ifdef DEBUG_CFG
							g_print("LOG-Managecfg.c: Image -> %s\n",DataTxtEntry[ptScan].cMsg[0].cMessage);
						#endif
						if (strcmp(DataTxtEntry[ptScan].cMsg[0].cMessage, "") != 0)
						{

							#ifdef DEBUG_CFG
								g_print ("LOG-Managecfg.c: Writing image config and position\n");
							#endif

							fprintf (fichier,"LineID=%i\n",ptScan);
							fprintf (fichier,"LineType=%i\n",DataTxtEntry[ptScan].type);
							fprintf (fichier,"0=%s\n", DataTxtEntry[ptScan].cMsg[0].cMessage) ;

						}
					}
				}
				ptScan=ptScan+1;
			}
		}
	}*/
	fclose (fichier) ;
	/*CreateTheme()    ;*/
return EXIT_SUCCESS;
}

void CreateTheme(char *conf)
{
FILE *fichier      ;         /*    pointeur vers un type fichier    */
char CheckConf[128];

/*ptr_pos = strstr (conf, ".");

if (ptr_pos==NULL)
{
    strncpy(CheckConf, conf, strlen(conf)+1);
    strncat(CheckConf, ".esp", 5);
    #ifdef DEBUG_CFG
        printf( "LOG-Managecfg.c: Adding ESP Ext File name -> %s \n", CheckConf);
    #endif
}else{
    strncpy(CheckConf, conf, strlen(conf)+1);
    #ifdef DEBUG_CFG
        printf( "LOG-Managecfg.c: ESP ext already here File name -> %s \n", CheckConf);
    #endif
}*/

/*strcpy(CheckConf, conf);
CheckConf[strlen(CheckConf)]='\0';*/

char *ptr_pos = NULL;

ptr_pos = strstr (conf, ".");

if (ptr_pos==NULL)
{
    strncpy(CheckConf, conf, strlen(conf)+1);
    strncat(CheckConf, ".j3d", 5);
    #ifdef DEBUG_CFG
        printf( "LOG-Managecfg.c: Adding J3D Ext File name -> %s \n", CheckConf);
    #endif
}else{
    strncpy(CheckConf, conf, strlen(conf)+1);
    #ifdef DEBUG_CFG
        printf( "LOG-Managecfg.c: ESP J3D already here File name -> %s \n", CheckConf);
    #endif
}


fichier = fopen (CheckConf, "wt") ;          /*    ouverture du fichier 'mon_fichier.txt'    */
                                             /*    pour ecriture (w) en mode texte (t)       */

if (fichier == NULL)                         /*    test de reussite                     */
{                                            /*    le pointeur n'est pas valide => stop */
    printf (ERRSAVE) ;                       /*    message d'alerte                     */
    exit (0) ;                               /*    terminer le programme                */
}
    fprintf (fichier,"EspStyle=%i\n"    , OglScene->__model__      ); /*Style des modeles               */
    fprintf (fichier,"EspStyleAnim=%i\n", OglScene->__style_anim__ ); /*Style de l'animation            */
    fprintf (fichier,"EspSpeedAnim=%f\n" , OglScene->__speed__       ); /*Style de l'animation            */
    fprintf (fichier,"HideToolbar=%i\n" , OglScene->__iHideToolbar__ ); /*Style de l'animation            */
    #ifdef DEBUG_CFG
        g_print ("LOG-Managecfg.c: Saving world color\n");
    #endif

    fprintf (fichier,"OglScene->__aWorldColor__[0]=%f\n"    , OglScene->__aWorldColor__[0]  ); /* Object 0 x */
    fprintf (fichier,"OglScene->__aWorldColor__[1]=%f\n"    , OglScene->__aWorldColor__[1]  ); /* Object 0 y */
    fprintf (fichier,"OglScene->__aWorldColor__[2]=%f\n"    , OglScene->__aWorldColor__[2]  ); /* Object 0 z */


    fprintf (fichier,"OglScene->__fCurPlaySize__=%f\n"  , OglScene->__fCurPlaySize__  );
    fprintf (fichier,"OglScene->__fArchiveSize__=%f\n"  , OglScene->__fArchiveSize__  );
    fprintf (fichier,"OglScene->__iArchiveMode__=%i\n"  , OglScene->__iArchiveMode__  );
    fprintf (fichier,"OglScene->__aArchivePos__[0]=%f\n", OglScene->__aArchivePos__[0]);
    fprintf (fichier,"OglScene->__aArchivePos__[1]=%f\n", OglScene->__aArchivePos__[1]);
    fprintf (fichier,"font_struct->iSpaceLine=%i\n"     , font_struct->iSpaceLine    );
    fprintf (fichier,"AlwaysShowInfo=%i\n"  , OglScene->__iAlwaysDispInf__   );
    #ifdef DEBUG_CFG
        g_print ("LOG-Managecfg.c: Saving object position\n");
    #endif

    fprintf (fichier,"OglObject[OglScene->__iCurrentPlay__].x=%f\n", OglObject[OglScene->__iCurrentPlay__].x  );
    fprintf (fichier,"OglObject[OglScene->__iCurrentPlay__].y=%f\n", OglObject[OglScene->__iCurrentPlay__].y  );
    fprintf (fichier,"OglObject[OglScene->__iCurrentPlay__].z=%f\n", OglObject[OglScene->__iCurrentPlay__].z  );
    fprintf (fichier,"Current_playing_ref=%i\n",OglScene->__iActCurPlayRef__);
    fprintf (fichier,"Archive_ref=%i\n"        ,OglScene->__iActArchRef__   );
    fprintf (fichier,"OglObject[2].x=%f\n"    , OglObject[2].x  );
    fprintf (fichier,"OglObject[2].y=%f\n"    , OglObject[2].y  );
    fprintf (fichier,"OglObject[2].z=%f\n"    , OglObject[2].z  );
    #ifdef DEBUG_CFG
        g_print ("LOG-Managecfg.c: Saving toolbar settings\n");
    #endif
    fprintf (fichier,"OglObject[3].x=%f\n"    , OglObject[3].x  );
    fprintf (fichier,"OglObject[3].y=%f\n"    , OglObject[3].y  );
    fprintf (fichier,"OglObject[3].z=%f\n"    , OglObject[3].z  );

    #ifdef DEBUG_CFG
        g_print ("LOG-Managecfg.c: Saving background settings\n");
    #endif

    fprintf (fichier,"SeaLevel=%f\n" , OglScene->__fGroundPos__   );

    fprintf (fichier,"BackgrndPnl_Hidden=%i\n" , OglObject[1].hidden   );
    fprintf (fichier,"BackgrndPnl_X=%f\n"      , OglObject[1].x        );
    fprintf (fichier,"BackgrndPnl_Y=%f\n"      , OglObject[1].y        );
    fprintf (fichier,"BackgrndPnl_Z=%f\n"      , OglObject[1].z        );
    fprintf (fichier,"BackgrndPnl_red=%f\n"    , OglObject[1].red       );
    fprintf (fichier,"BackgrndPnl_green=%f\n"  , OglObject[1].green     );
    fprintf (fichier,"BackgrndPnl_blue=%f\n"   , OglObject[1].blue      );
    fprintf (fichier,"BackgrndPnl_width=%f\n"  , OglObject[1].fWidth    );
    fprintf (fichier,"BackgrndPnl_height=%f\n" , OglObject[1].fHeight   );
    fprintf (fichier,"SponFontAli=%i\n", font_struct->iTextAlign  )  ;
    fprintf (fichier,"SponFontAct=%i\n", OglScene->__ActSpons__ )  ;    /*Font active for messaging system*/
    /*fprintf (fichier,"SponFontNbr=%i\n", OglScene->iNbrEntrySpon)  ;*/    /*Font active for messaging system*/
    fprintf (fichier,"SponFontPat=%s\n", font_struct->cFontPath   )  ;    /*Font active for messaging system*/
    fprintf (fichier,"SponFontRed=%f\n", font_struct->red         )  ;    /*Red Color for messaging system  */
    fprintf (fichier,"SponFontGreen=%f\n", font_struct->green     )  ;    /*Green Color for messaging system*/
    fprintf (fichier,"SponFontBlue=%f\n", font_struct->blue       )  ;    /*Blue Color for messaging system */
    fprintf (fichier,"SponFontSize=%i\n", font_struct->iFontSize  )  ;    /*Font size for messaging system  */
    fprintf (fichier,"SponFontTime=%f\n", OglScene->__fTimeSpons__); /*Font time for messaging system  */
    fprintf (fichier,"SponFontUpd=%i\n", OglScene->__UpdSpons__ )  ;    /*Font update for messaging system*/
    #ifdef DEBUG_CFG
        g_print("LOG-Managecfg.c: Start writing toolbar configuration\n");
    #endif
	fprintf (fichier,"ToolbarSkin=%s\n"    , j3denv->__sTbCurSkin__) ;      
 
fclose (fichier) ;
return;
}


int LoadKey (char *key,char *value)
{
    /*int ptScan=0;
    int i=0;*/

    /**J3D**/

	if (strcmp(key, "J3DScript") == 0)
	{
	    /*strncpy(OglScene->__iScript__,value,strlen(value)-1);
	    OglScene->__iScript__[strlen(OglScene->__iScript__)-1]='\0';*/
        strcpy(j3denv->__sCurrentScript__,value);
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)] = '\0';
            #ifdef DEBUG_CFG
                printf("LOG-Managecfg.c: j3denv->__sCurrentScript__ -> %s \n", j3denv->__sCurrentScript__);
            #endif


	}
	if (strcmp(key, "CurrentTheme") == 0)
	{
	    /*strncpy(OglScene->__iScript__,value,strlen(value)-1);
	    OglScene->__iScript__[strlen(OglScene->__iScript__)-1]='\0';*/
	    strcpy(j3denv->__sCurrentTheme__,value);
        j3denv->__sCurrentTheme__[strlen(j3denv->__sCurrentTheme__)] = '\0';
            #ifdef DEBUG_CFG
                printf("LOG-Managecfg.c: j3denv.__sCurrentTheme__ -> %s \n", j3denv->__sCurrentTheme__);
            #endif


	}
	/**Toolbar skin**/
	if (strcmp(key, "ToolbarSkin") == 0)
	{strcpy( j3denv->__sTbCurSkin__, (char*)value);} 
    /***Sauvegarde des images**/
	if (strcmp(key, "OglScene->CurrentPlay") == 0)
	{strcpy( OglScene->CurrentPlay, (char*)value);}
    if (strcmp(key, "HideToolbar") == 0)
    {OglScene->__iHideToolbar__=atoi(value);}
    /**Sauvegarde du style de modele **/
	if (strcmp(key, "EspStyle") == 0)
	{
        if (strcmp(value, "0") == 0)
        {OglScene->__model__=0;}
        if (strcmp(value, "1") == 0)
        {OglScene->__model__=1;}
        if (strcmp(value, "2") == 0)
        {OglScene->__model__=2;}
        if (strcmp(value, "3") == 0)
        {OglScene->__model__=3;}
        if (strcmp(value, "4") == 0)
        {OglScene->__model__=4;}
        if (strcmp(value, "5") == 0)
        {OglScene->__model__=5;}
	}

	/**Restore scene style             **/
	if (strcmp(key, "EspStyleAnim") == 0)
	{

        if (strcmp(value, "0") == 0)
        {OglScene->__style_anim__=0;}

        if (strcmp(value, "1") == 0)
        {OglScene->__style_anim__=1;}


        if (strcmp(value, "2") == 0)
        {OglScene->__style_anim__=2;}

        if (strcmp(value, "3") == 0)
        {OglScene->__style_anim__=3;}

        if (strcmp(value, "4") == 0)
        {OglScene->__style_anim__=4;}
	}

    /**Restore scene speed             **/
	if (strcmp(key, "EspSpeedAnim") == 0)
	{
        OglScene->__speed__=atof(value);
	}
    /**Sauvegarde du style d'affichage ( 1 equipe,2 equipes etc ... )**/
	/*if (strcmp(key, "EspModTeam") == 0)
	{

        if (strcmp(value, "0") == 0)
        {OglScene->__iModeTeam__=0;}

        if (strcmp(value, "1") == 0)
        {OglScene->__iModeTeam__=1;}


        if (strcmp(value, "2") == 0)
        {OglScene->__iModeTeam__=2;}

        if (strcmp(value, "3") == 0)
        {OglScene->__iModeTeam__=3;}
	}*/

    /**Reflection**/
    if (strcmp(key, "Current_playing_ref") == 0)
	{OglScene->__iActCurPlayRef__=atoi(value);}

    if (strcmp(key, "Archive_ref") == 0)
	{OglScene->__iActArchRef__=atoi(value);}

    /**Parametre de background**/
    if (strcmp(key, "BackgrndPnl_Hidden") == 0)
	{
	    if (atoi(value)==1)
	    {
            OglObject[1].hidden=1;
	    }else{
	        OglObject[1].hidden=0;
	    }
	}
    if (strcmp(key, "BackgrndPnl_X") == 0)
	{OglObject[1].x=atof(value);}
    if (strcmp(key, "BackgrndPnl_Y") == 0)
	{OglObject[1].y=atof(value);}
    if (strcmp(key, "BackgrndPnl_Z") == 0)
	{OglObject[1].z=atof(value);}
    if (strcmp(key, "BackgrndPnl_red") == 0)
	{OglObject[1].red=atof(value);}
    if (strcmp(key, "BackgrndPnl_green") == 0)
	{OglObject[1].green=atof(value);}
    if (strcmp(key, "BackgrndPnl_blue") == 0)
	{OglObject[1].blue=atof(value);}
    if (strcmp(key, "BackgrndPnl_width") == 0)
	{OglObject[1].fWidth=atof(value);}
    if (strcmp(key, "BackgrndPnl_height") == 0)
	{OglObject[1].fHeight=atof(value);}
    if (strcmp(key, "SeaLevel") == 0)
	{OglScene->__fGroundPos__=atof(value);}
    /****************************/

    /**Sponsors system**/

	if (strcmp(key, "SponFontAct") == 0)
	{
        if (strcmp(value, "1") == 0)
        {OglScene->__ActSpons__=1;}
	}

    if (strcmp(key, "SponFontAli") == 0)
	{
        font_struct->iTextAlign=atoi(value);
	}

    if (strcmp(key, "SponFontUpd") == 0)
	{
        if (strcmp(value, "1") == 0)
		{OglScene->__UpdSpons__=1;}
	}
    /*if (strcmp(key, "SponFontNbr") == 0)
	{
        OglScene->iNbrEntrySpon=atoi(value);
	}*/
    if (strcmp(key, "SponFontPat") == 0)
	{
        strcpy( font_struct->cFontPath,value);
	}

    if (strcmp(key, "SponFontSize") == 0)
	{
         font_struct->iFontSize=atoi(value);
	}
    if (strcmp(key, "SponFontRed") == 0)
	{
         font_struct->red=atof(value);
	}
    if (strcmp(key, "SponFontGreen") == 0)
	{
         font_struct->green=atof(value);
	}
    if (strcmp(key, "SponFontBlue") == 0)
	{
         font_struct->blue=atof(value);
	}

    if (strcmp(key, "SponFontTime") == 0)
	{
        OglScene->__fTimeSpons__=atof(value);
	}

    if (strcmp(key, "OglScene->__fCurPlaySize__") == 0)
	{OglScene->__fCurPlaySize__=atof(value);}
    if (strcmp(key, "OglScene->__fArchiveSize__") == 0)
	{OglScene->__fArchiveSize__=atof(value);}
    if (strcmp(key, "OglScene->__iArchiveMode__") == 0)
	{OglScene->__iArchiveMode__=atoi(value);}
	
    if (strcmp(key, "OglScene->__aArchivePos__[0]") == 0)
	{OglScene->__aArchivePos__[0]=atof(value);}	
    if (strcmp(key, "OglScene->__aArchivePos__[1]") == 0)
	{OglScene->__aArchivePos__[1]=atof(value);}	
	
    if (strcmp(key, "font_struct->iSpaceLine") == 0)
	{font_struct->iSpaceLine=atoi(value);}

    if (strcmp(key, "AlwaysShowInfo") == 0)
	{OglScene->__iAlwaysDispInf__=atoi(value);}

    if (strcmp(key, "OglObject[OglScene->__iCurrentPlay__].x") == 0)
	{OglObject[OglScene->__iCurrentPlay__].x=atof(value);}
    if (strcmp(key, "OglObject[OglScene->__iCurrentPlay__].y") == 0)
	{OglObject[OglScene->__iCurrentPlay__].y=atof(value);}
    if (strcmp(key, "OglObject[OglScene->__iCurrentPlay__].z") == 0)
	{OglObject[OglScene->__iCurrentPlay__].z=atof(value);}
    if (strcmp(key, "OglObject[2].y") == 0)
	{OglObject[2].y=atof(value);}
    if (strcmp(key, "OglObject[2].x") == 0)
	{OglObject[2].x=atof(value);}


    if (strcmp(key, "OglObject[3].y") == 0)
	{OglObject[3].y=atof(value);}
    if (strcmp(key, "OglObject[3].x") == 0)
	{OglObject[3].x=atof(value);}
    if (strcmp(key, "OglObject[3].z") == 0)
	{OglObject[3].z=atof(value);

    OglObject[4].x=OglObject[3].x+1;
	OglObject[4].y=OglObject[3].y;
	OglObject[4].z=OglObject[3].z;
    /**Configure Player Prev**/
	OglObject[5].x=OglObject[3].x+2;
	OglObject[5].y=OglObject[3].y;
	OglObject[5].z=OglObject[3].z;
	/**Configure Player Next**/
	OglObject[6].x=OglObject[3].x+3;
	OglObject[6].y=OglObject[3].y;
	OglObject[6].z=OglObject[3].z;


	}

    /*if (strcmp(key, "LineID") == 0)
	{
        iReadSponsors = 1;
        iCurrentRead  = atoi(value);
        iCurrentType  = 99;
        iReadKeyNow   = 0 ;

	}*/

    /*if (strcmp(key, "LineType") == 0)
	{
        iCurrentType=atoi(value);
        DataTxtEntry[iCurrentRead].type=atoi(value);
	}*/

    if (strcmp(key, "OglScene->__aWorldColor__[0]") == 0)
	{OglScene->__aWorldColor__[0]=atof(value);}

    if (strcmp(key, "OglScene->__aWorldColor__[1]") == 0)
	{OglScene->__aWorldColor__[1]=atof(value);}

    if (strcmp(key, "OglScene->__aWorldColor__[2]") == 0)
	{OglScene->__aWorldColor__[2]=atof(value);}

return 1;
}
