/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            timer.c							 *
 *************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <gtk/gtk.h>
#include <glade/glade.h>

#include "../include/main.h"
#include "../include/timer.h"
#include "../include/managecfg.h"


int timerInterval = 0;
int timerHandlerPipeFd = -1;

void timerHandler(int ms)
{
		/*fd_set ensemble_lecture;
	
			if(timerHandlerPipeFd != -1)
			{
					FD_ZERO( &ensemble_lecture );
					FD_SET( timerHandlerPipeFd, &ensemble_lecture );
					if( select( FD_SETSIZE, &ensemble_lecture, NULL, NULL, NULL ) < 0 )
					{
						perror( "Select" );
					}
					if( FD_ISSET( timerHandlerPipeFd, &ensemble_lecture ) )
					{

						ReadInfo(timerHandlerPipeFd);
						close(timerHandlerPipeFd);
					}
				
				
			}

			timerHandlerPipeFd = exec_pipe_command("query",j3denv->__sCurrentScript__);*/
		
	
        /* warning : using printf from a signal handler is not supported */
	   if(timerHandlerPipeFd != -1)
	   {
    	   fd_set ensemble_lecture;
		       struct timeval tv;
       int r;

       FD_ZERO( &ensemble_lecture );
       FD_SET( timerHandlerPipeFd, &ensemble_lecture );
       tv.tv_sec = 1;
       tv.tv_usec = 0;

       switch(r = select( timerHandlerPipeFd+1 , &ensemble_lecture, NULL, NULL, &tv ))
       {
           case 1:
               if( FD_ISSET( timerHandlerPipeFd, &ensemble_lecture ) )
               {
                   ReadInfo(timerHandlerPipeFd);
                   close(timerHandlerPipeFd);
               }
              break;
           case 0:
               printf("**Timeout**\n");
               break;
           default:
               perror("select");
               break;
       }
   }
   timerHandlerPipeFd = exec_pipe_command("query",j3denv->__sCurrentScript__);
   /* warning : using printf from a signal handler is not supported */
}

/**Piped version**/
int exec_pipe_command(char *command,char *path)
{
	pid_t pid;
	int fds[2];

	if(pipe(fds) == -1)
	{
		perror("pipe");
		return -1;
	}
	#ifdef DEBUG_TIMER
		g_print("Timer: Start fork %s\n",path);
	#endif
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork");
			return -1;
		case 0: // child
			close(fds[0]); // close read-end of pipe
			dup2(fds[1], 1); // writing to stdout writes into the pipe
			execlp(path, path, command, NULL);
			perror("execlp");
			exit(1);
		default: /* parent */
			close(fds[1]); /* close write-end of pipe */
			/* don't waitpid here, use SIGCHLD or SA_NOCLDWAIT */
			return fds[0]; /* return the file descriptor */
	}
    return -1;
}

void installTimerEvents(int ms)
{
    signal(SIGALRM, timerHandler);

	timerInterval = ms;
	struct itimerval timerval;
	timerval.it_value.tv_sec  = timerval.it_interval.tv_sec  =  ms/1000;
	timerval.it_value.tv_usec = timerval.it_interval.tv_usec = (ms%1000) * 1000;
	setitimer(ITIMER_REAL, &timerval, NULL);

	/* automatic child termination */
	signal(SIGCHLD, SIG_IGN);
}

